with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Bid_Win; use Callbacks_Bid_Win;
with Bid_Window_Pkg.Callbacks; use Bid_Window_Pkg.Callbacks;
with Gtk.Main; use Gtk.Main;
with Timeout_Bid_Win;
with Gtk.Widget; use Gtk.Widget;
with Auction_Interface; use Auction_Interface;
with Bid_Window_Pkg.Callbacks; use Bid_Window_Pkg.Callbacks;

package body Bid_Window_Pkg is

   procedure Gtk_New (Bid_Window : out Bid_Window_Access;
                      User_Id : User_Identifier_Type;
                      My_Auction_ID :  Auction_Identifier_Type) is
   begin
      Bid_Window := new Bid_Window_Record;
      Bid_Window.Auction_ID := My_Auction_Id;
      Bid_Window.User_ID := User_Id;
      Bid_Window_Pkg.Initialize (Bid_Window);
   end Gtk_New;

   procedure Initialize (Bid_Window : access Bid_Window_Record'Class) is
      Bid_Spinbutton_Adj : Gtk_Adjustment;
      The_Accel_Group : Gtk_Accel_Group;
      Temp_Gfloat : Gfloat;
      Temp_Gfloat2 : Gfloat;
      Current_Bid, Initial_Bid : Natural;

   begin
      Gtk.Window.Initialize (Bid_Window, Window_Toplevel);
      Window_Callback.Connect
        (Bid_Window, "destroy",
         Window_Callback.To_Marshaller (On_Bid_Window_Destroy'Access));
      Return_Callback.Connect
        (Bid_Window, "delete_event", On_Bid_Window_Delete_Event'Access);

      Set_Policy (Bid_Window, False, False, False);
      Set_Position (Bid_Window, Win_Pos_None);
      Set_Modal (Bid_Window, False);

      Gtk_New (Bid_Window.Fixed1);
      Add (Bid_Window, Bid_Window.Fixed1);

      Gtk_New (Bid_Window.Frame8, "Status");
      Set_UPosition (Bid_Window.Frame8, 128, 8);
      Set_USize (Bid_Window.Frame8, 240, 88);
      Put (Bid_Window.Fixed1, Bid_Window.Frame8, 128, 8);
      Set_Shadow_Type (Bid_Window.Frame8, Shadow_Etched_In);

    --   Gtk_New (Bid_Window.Label4, Get_Description (Bid_Window.Auction_ID,
--                                                     Bid_Window.User_Id));
--       --  Gtk_New (Bid_Window.Label4, Get_Description (My_Auction.all));
--       -- Gtk_New (Bid_Window.Label4, "A completer...");
--       Add (Bid_Window.Frame8, Bid_Window.Label4);
--       Set_Alignment (Bid_Window.Label4, 0.32, 0.5);
--       Set_Padding (Bid_Window.Label4, 0, 0);
--       Set_Justify (Bid_Window.Label4, Justify_Left);
--       Set_Line_Wrap (Bid_Window.Label4, False);


      Gtk_New (Bid_Window.Frame5, "Title");
      Set_UPosition (Bid_Window.Frame5, 8, 8);
      Set_USize (Bid_Window.Frame5, 104, 40);
      Put (Bid_Window.Fixed1, Bid_Window.Frame5, 8, 8);
      Set_Shadow_Type (Bid_Window.Frame5, Shadow_Etched_In);

      declare
         S : String := Get_Name (Bid_Window.Auction_ID,
                                 Bid_Window.User_Id);
      begin
         Gtk_New (Bid_Window.Name_Label, S);
         --  Gtk_New (Bid_Window.Name_Label, "A completer...");
         Add (Bid_Window.Frame5, Bid_Window.Name_Label);
         Set_Alignment (Bid_Window.Name_Label, 0.5, 0.5);
         Set_Padding (Bid_Window.Name_Label, 0, 0);
         Set_Justify (Bid_Window.Name_Label, Justify_Center);
         Set_Line_Wrap (Bid_Window.Name_Label, False);
         Set_Title (Bid_Window, "Bidder: " & Get_Name (Bid_Window.User_Id) &
                    " Auction: " & S);
      end;

      Gtk_New (Bid_Window.Frame4, "Opening Bid");
      Set_UPosition (Bid_Window.Frame4, 8, 56);
      Set_USize (Bid_Window.Frame4, 104, 40);
      Put (Bid_Window.Fixed1, Bid_Window.Frame4, 8, 56);
      Set_Shadow_Type (Bid_Window.Frame4, Shadow_Etched_In);

      Initial_Bid := Get_Initial_Bid (Bid_Window.Auction_ID,
                                      Bid_Window.User_Id);
      Gtk_New (Bid_Window.Start_Bid_Label,
               Natural'Image (Initial_Bid));
      --  Gtk_New (Bid_Window.Start_Bid_Label, "A completer...");
      Add (Bid_Window.Frame4, Bid_Window.Start_Bid_Label);
      Set_Alignment (Bid_Window.Start_Bid_Label, 0.5, 0.5);
      Set_Padding (Bid_Window.Start_Bid_Label, 0, 0);
      Set_Justify (Bid_Window.Start_Bid_Label, Justify_Center);
      Set_Line_Wrap (Bid_Window.Start_Bid_Label, False);

      Gtk_New (Bid_Window.Frame6, "Current Bid");
      Set_UPosition (Bid_Window.Frame6, 8, 104);
      Set_USize (Bid_Window.Frame6, 104, 40);
      Put (Bid_Window.Fixed1, Bid_Window.Frame6, 8, 104);
      Set_Shadow_Type (Bid_Window.Frame6, Shadow_Etched_In);

      Current_Bid := Get_Current_Bid (Bid_Window.Auction_ID,
                                      Bid_Window.User_Id);

      Gtk_New (Bid_Window.Current_Bid_Label,
               Natural'Image (Current_Bid));
      --  Gtk_New (Bid_Window.Current_Bid_Label, "A completer...");
      Add (Bid_Window.Frame6, Bid_Window.Current_Bid_Label);
      Set_Alignment (Bid_Window.Current_Bid_Label, 0.5, 0.5);
      Set_Padding (Bid_Window.Current_Bid_Label, 0, 0);
      Set_Justify (Bid_Window.Current_Bid_Label, Justify_Center);
      Set_Line_Wrap (Bid_Window.Current_Bid_Label, False);

      Gtk_New (Bid_Window.Frame7);
      Set_UPosition (Bid_Window.Frame7, 128, 111);
      Set_USize (Bid_Window.Frame7, 120, 33);
      Put (Bid_Window.Fixed1, Bid_Window.Frame7, 128, 111);
      Set_Shadow_Type (Bid_Window.Frame7, Shadow_Etched_In);

      Gtk_New_Hbox (Bid_Window.Hbox1, True, 0);
      Add (Bid_Window.Frame7, Bid_Window.Hbox1);
      Set_UPosition (Bid_Window.Frame7, 247, 108);
      --------------------------
      Temp_Gfloat := Gfloat (Current_Bid + 1);
      Temp_Gfloat2 := Gfloat (Initial_Bid + 1);
      if Temp_Gfloat < Temp_Gfloat2 then
         Temp_Gfloat := Temp_Gfloat2 - 1.0;
      end if;
      --------------------------

      Gtk_New (Bid_Spinbutton_Adj, Temp_Gfloat,
               Temp_Gfloat, Temp_Gfloat + 5000.0, 1.0, 5.0, 5.0);
      Gtk_New (Bid_Window.Bid_Spinbutton, Bid_Spinbutton_Adj, 0.5, 0);
      Pack_Start (Bid_Window.Hbox1, Bid_Window.Bid_Spinbutton, True, True, 0);
      Set_Numeric (Bid_Window.Bid_Spinbutton, False);
      Set_Snap_To_Ticks (Bid_Window.Bid_Spinbutton, False);
      Set_Update_Policy (Bid_Window.Bid_Spinbutton, Update_If_Valid);
      --  Set_Value (Bid_Window.Bid_Spinbutton, Temp_Gfloat);
      Set_Wrap (Bid_Window.Bid_Spinbutton, False);

      Gtk_New (Bid_Window.Bid_Button, "Bid");
      Pack_Start (Bid_Window.Hbox1, Bid_Window.Bid_Button, True, True, 0);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Bid_Window, The_Accel_Group);
      Add_Accelerator (Bid_Window.Bid_Button, "pressed",
                       The_Accel_Group, GDK_Return, 0, Accel_Visible);
      Button_Callback.Connect
        (Bid_Window.Bid_Button, "pressed",
         Button_Callback.To_Marshaller (On_Bid_Button_Pressed'Access),
         Bid_Window_Access (Bid_Window));
      Set_Border_Width (Bid_Window.Bid_Button, 3);

      ----------------------------------------------------------
      --  BIDOUILLE MANUELLE POUR faire pixmap + label..
      ----------------------------------------------------------

      --  Load Pixmaps
      Bid_Window.Question_Pixmap := Create_Pixmap ("question.xpm", Bid_Window);
      --  Bid_Window.Smile_Pixmap := Create_Pixmap ("smile.xpm", Bid_Window);
      --  Bid_Window.Warning_Pixmap := Create_Pixmap ("warning.xpm", Bid_Window);
      --  Bid_Window.Lock_Pixmap := Create_Pixmap ("lock.xpm", Bid_Window);
      --  Bid_Window.Bomb_Pixmap := Create_Pixmap ("bomb.xpm", Bid_Window);
      Bid_Window.Stop_Pixmap := Create_Pixmap ("stop.xpm", Bid_Window);
      Bid_Window.Sickface_Pixmap := Create_Pixmap ("sickface.xpm", Bid_Window);
      Bid_Window.Smiley_Pixmap := Create_Pixmap ("smiley.xpm", Bid_Window);
      Bid_Window.Smiley3_Pixmap := Create_Pixmap ("smiley3.xpm", Bid_Window);

      Gtk_New_Vbox (Bid_Window.Vbox33, True, 2);
      Add (Bid_Window.Frame8, Bid_Window.Vbox33);
      --  Pack_Start (Bid_Window.Frame8, Bid_Window.Vbox33, True, True, 0);
      Set_Border_Width (Bid_Window.Vbox33, 0);

      Bid_Window.The_Pixmap := Bid_Window.Question_Pixmap;

      Pack_Start (Bid_Window.Vbox33, Bid_Window.The_Pixmap, True, True, 0);
      --  Set_USize (Bid_Window.The_Pixmap, 41, 15);
      Set_Alignment (Bid_Window.The_Pixmap, 0.5, 0.5);
      Set_Padding (Bid_Window.The_Pixmap, 0, 0);

      Gtk_New (Bid_Window.Label33, "Please enter your bid" & ASCII.LF &
               "and press ""Bid"".");
      Set_USize (Bid_Window.Label33, 205, 48);
      Pack_Start (Bid_Window.Vbox33, Bid_Window.Label33, False, False, 0);
      Set_Alignment (Bid_Window.Label33, 0.5, 0.5);
      Set_Padding (Bid_Window.Label33, 0, 0);
      Set_Justify (Bid_Window.Label33, Justify_Center);
      Set_Line_Wrap (Bid_Window.Label33, False);
      ----------------------------------------------------------

      declare
         Ok : Boolean := Update_Infos (Bid_Window_Access (Bid_Window));
      begin
         null;
      end;

      Bid_Window.My_Timeout_Handler_Id :=
        Timeout_Bid_Win.Add (6000, Update_Infos'Access,
                             Bid_Window_Access(Bid_Window));

   end Initialize;

   procedure Cosmetics (Bid_Window : access Bid_Window_Record'Class) is
   begin
      if Bid_Window.Button_Is_Quit then
         Hide (Bid_Window.Bid_Spinbutton);
      end if;
   end Cosmetics;

end Bid_Window_Pkg;
