with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Callbacks_Name_Exists; use Callbacks_Name_Exists;
with Name_Exists_Dialog_Pkg.Callbacks;
use Name_Exists_Dialog_Pkg.Callbacks;

package body Name_Exists_Dialog_Pkg is

   procedure Gtk_New (Name_Exists_Dialog : out Name_Exists_Dialog_Access)
   is
   begin
      Name_Exists_Dialog := new Name_Exists_Dialog_Record;
      Name_Exists_Dialog_Pkg.Initialize (Name_Exists_Dialog);
   end Gtk_New;

   procedure Initialize
     (Name_Exists_Dialog : access Name_Exists_Dialog_Record'Class) is
      The_Accel_Group : Gtk_Accel_Group;

   begin
      Gtk.Dialog.Initialize (Name_Exists_Dialog);
      Set_Title (Name_Exists_Dialog, "Warning: Overbid");
      Set_Policy (Name_Exists_Dialog, False, False, False);
      Set_Position (Name_Exists_Dialog, Win_Pos_Mouse);
      Set_Modal (Name_Exists_Dialog, False);

      Name_Exists_Dialog.Dialog_Vbox1 := Get_Vbox (Name_Exists_Dialog);
      Set_Homogeneous (Name_Exists_Dialog.Dialog_Vbox1, False);
      Set_Spacing (Name_Exists_Dialog.Dialog_Vbox1, 0);

      Gtk_New_Hbox (Name_Exists_Dialog.Hbox1, False, 2);
      Pack_Start (Name_Exists_Dialog.Dialog_Vbox1,
                  Name_Exists_Dialog.Hbox1, True, True, 0);
      Set_Border_Width (Name_Exists_Dialog.Hbox1, 1);

      Name_Exists_Dialog.Warning_Pixmap :=
        Create_Pixmap ("warning.xpm", Name_Exists_Dialog);
      Pack_Start (Name_Exists_Dialog.Hbox1,
                  Name_Exists_Dialog.Warning_Pixmap, True, True, 0);
      Set_USize (Name_Exists_Dialog.Warning_Pixmap, 41, 15);
      Set_Alignment (Name_Exists_Dialog.Warning_Pixmap, 0.5, 0.5);
      Set_Padding (Name_Exists_Dialog.Warning_Pixmap, 0, 0);

      Gtk_New (Name_Exists_Dialog.Label1,
               "Sorry, this auction still exists." & ASCII.LF & "Choose an other title.");
      Set_USize (Name_Exists_Dialog.Label1, 205, 48);
      Pack_Start (Name_Exists_Dialog.Hbox1,
                  Name_Exists_Dialog.Label1, False, False, 0);
      Set_Alignment (Name_Exists_Dialog.Label1, 0.5, 0.5);
      Set_Padding (Name_Exists_Dialog.Label1, 0, 0);
      Set_Justify (Name_Exists_Dialog.Label1, Justify_Center);
      Set_Line_Wrap (Name_Exists_Dialog.Label1, False);

      Name_Exists_Dialog.Dialog_Action_Area1 :=
        Get_Action_Area (Name_Exists_Dialog);
      Set_Border_Width (Name_Exists_Dialog.Dialog_Action_Area1, 4);
      Set_Homogeneous (Name_Exists_Dialog.Dialog_Action_Area1, True);
      Set_Spacing (Name_Exists_Dialog.Dialog_Action_Area1, 1);

      Gtk_New (Name_Exists_Dialog.Ok_Button, "OK");
      Set_Flags (Name_Exists_Dialog.Ok_Button, Can_Default);
      Set_Flags (Name_Exists_Dialog.Ok_Button, Can_Focus);

      Grab_Focus (Name_Exists_Dialog.Ok_Button);
      Grab_Default (Name_Exists_Dialog.Ok_Button);
      Pack_Start (Name_Exists_Dialog.Dialog_Action_Area1,
                  Name_Exists_Dialog.Ok_Button, False, False, 0);
      Set_USize (Name_Exists_Dialog.Ok_Button, 79, 33);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Name_Exists_Dialog, The_Accel_Group);
      Add_Accelerator (Name_Exists_Dialog.Ok_Button, "pressed",
                       The_Accel_Group, GDK_Return, 0, Accel_Visible);
      Button_Callback.Connect
        (Name_Exists_Dialog.Ok_Button, "pressed",
         Button_Callback.To_Marshaller (On_Ok_Button_Pressed'Access),
         Name_Exists_Dialog_Access (Name_Exists_Dialog));
   end Initialize;

end Name_Exists_Dialog_Pkg;
