with Gtk.Widget; use Gtk.Widget;
--  with Debug_Window; use Debug_Window;

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Ada.Integer_Text_IO;
use Ada.Integer_Text_IO;
with Ada.Exceptions; use Ada.Exceptions;
with Gdk.Types; use Gdk.Types;
with Gdk.Event; use Gdk.Event;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;
with Debug_Auction;
with User_Interface;
--  with Sell_Command_Types; use Sell_Command_Types;
with Auction_Interface; use Auction_Interface;
with Sell_Window_Pkg; use Sell_Window_Pkg;
with Remote_String_Arrays; use Remote_String_Arrays;
with Name_Exists_Dialog_Pkg; use Name_Exists_Dialog_Pkg;

package body New_Auction_Win_Pkg.Callbacks is

   use Gtk.Arguments;

   function On_New_Auction_Window_Key_Press_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args;
      Auction_Win : New_Auction_Win_Access) return Boolean
   is
      Arg1 : Gdk_Event := To_Event (Params, 1);
   begin
      if Get_Key_Val (Arg1) = GDK_Escape then
         On_Cancel_B_Clicked (Auction_Win.Cancel_B, Auction_Win);
      end if;
      return False;
   end On_New_Auction_Window_Key_Press_Event;

   ----------------------------------------
   -- On_New_Auction_Window_Delete_Event --
   ----------------------------------------

   function On_New_Auction_Window_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean
   is
   begin
      return True;
   end On_New_Auction_Window_Delete_Event;
   ---------------------
   -- On_Ok_B_Clicked --
   ---------------------

   procedure On_Ok_B_Clicked
     (Object : access Gtk_Button_Record'Class;
      Auction_Win : New_Auction_Win_Access)
   is
      --  My_Title, My_Description : Unbounded_String;
      Last : Positive;
      Initial_Bid : Integer;
      Auction_ID : Auction_Identifier_Type;
      Seller_Auction_Window : Sell_Window_Access;
      Name_Exists_Dialog : Name_Exists_Dialog_Access;
    --  Start_Auction_Command : Start_Auction_Command_Type;
   begin
     --  Debug_Auction.Put_Line (Get_Text (Auction_Win.Name_Entry));
     --  Debug_Auction.Put_Line (Get_Text (Auction_Win.Description_Textbox));
      --  My_Title := To_Unbounded_String (Get_Text (Auction_Win.Name_Entry));
      --  My_Description :=
        --  To_Unbounded_String (Get_Chars (Auction_Win.Description_Textbox));
      Get (Get_Text (Auction_Win.Base_Bid_Entry), Initial_Bid, Last);
      --  Debug_Auction.Put_Line (Integer'Image (Initial_Bid));
      if Get_Text (Auction_Win.Name_Entry) /= ""
        and then (Initial_Bid > 0) then
         Auction_ID := User_Interface.Start_Auction
           (Auction_Win.User_Id,
            Get_Text (Auction_Win.Name_Entry),
            Get_Chars (Auction_Win.Description_Textbox),
            Initial_Bid);
         --  Start_Auction_Command.Title := My_Title;
         --  Start_Auction_Command.Description := My_Description;
         --  Start_Auction_Command.Initial_Bid := Initial_Bid;
         --  Auction_Win.Sell_Command_Buffer.Send (Start_Auction_Command);
         Gtk_New (Seller_Auction_Window, Auction_Win.User_ID, Auction_ID);
         Show_All (Seller_Auction_Window);
         Destroy_Cb (Auction_Win);
      else
         Debug_Auction.Put_Line ("New Auction: Not valid");
      end if;

   exception
      when E : others =>
         Debug_Auction.Put_Line
           ("New Auction window raised exception " & Exception_Name (E));
         Gtk_New (Name_Exists_Dialog);
         Show_All (Name_Exists_Dialog);
   end On_Ok_B_Clicked;

   -------------------------
   -- On_Cancel_B_Clicked --
   -------------------------

   procedure On_Cancel_B_Clicked
     (Object : access Gtk_Button_Record'Class;
      Auction_Win : New_Auction_Win_Access)
   is
   begin
      Destroy_Cb (Auction_Win);
   end On_Cancel_B_Clicked;

end New_Auction_Win_Pkg.Callbacks;
