with Gtk; use Gtk;
with Gtk.Enums; use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_New_Auction; use Callbacks_New_Auction;
with New_Auction_Win_Pkg.Callbacks; use New_Auction_Win_Pkg.Callbacks;

package body New_Auction_Win_Pkg is

   procedure Gtk_New (New_Auction_Win : out New_Auction_Win_Access;
                      User_ID : User_Identifier_Type) is
   begin
      New_Auction_Win := new New_Auction_Win_Record;
      New_Auction_Win.User_ID := User_ID;
      New_Auction_Win_Pkg.Initialize (New_Auction_Win);
   end Gtk_New;

   procedure Initialize
     (New_Auction_Win : access New_Auction_Win_Record'Class) is
   begin
      Gtk.Window.Initialize (New_Auction_Win, Window_Toplevel);
      Widg_Callback.Connect
        (New_Auction_Win, "key_press_event",
         On_New_Auction_Window_Key_Press_Event'Access,
         New_Auction_Win_Access (New_Auction_Win));

      Return_Callback.Connect
        (New_Auction_Win, "delete_event",
         On_New_Auction_Window_Delete_Event'Access);
      Set_Border_Width (New_Auction_Win, 5);

      Set_Title (New_Auction_Win, "New Auction for User: " &
                 Get_Name (New_Auction_Win.User_ID));

      Set_Policy (New_Auction_Win, False, True, False);
      Set_Position (New_Auction_Win, Win_Pos_None);
      Set_Modal (New_Auction_Win, False);

      Gtk_New_Vbox (New_Auction_Win.Vbox1, False, 0);
      Add (New_Auction_Win, New_Auction_Win.Vbox1);

      Gtk_New (New_Auction_Win.Table1, 3, 2, False);
      Pack_Start (New_Auction_Win.Vbox1,
                  New_Auction_Win.Table1, False, False, 0);
      Set_Row_Spacings (New_Auction_Win.Table1, 0);
      Set_Col_Spacings (New_Auction_Win.Table1, 0);

      Gtk_New (New_Auction_Win.Label1, "Auction Name : ");
      Attach (New_Auction_Win.Table1, New_Auction_Win.Label1, 0, 1, 0, 1,
              0, 0,
              0, 0);
      Set_Alignment (New_Auction_Win.Label1, 0.5, 0.5);
      Set_Padding (New_Auction_Win.Label1, 0, 0);
      Set_Justify (New_Auction_Win.Label1, Justify_Center);
      Set_Line_Wrap (New_Auction_Win.Label1, False);

      Gtk_New (New_Auction_Win.Label2, "Short Description : ");
      Attach (New_Auction_Win.Table1, New_Auction_Win.Label2, 0, 1, 1, 2,
              0, 0,
              0, 0);
      Set_Alignment (New_Auction_Win.Label2, 0.5, 0.5);
      Set_Padding (New_Auction_Win.Label2, 0, 0);
      Set_Justify (New_Auction_Win.Label2, Justify_Center);
      Set_Line_Wrap (New_Auction_Win.Label2, False);

      Gtk_New (New_Auction_Win.Label3, "Initial Bid : ");
      Attach (New_Auction_Win.Table1, New_Auction_Win.Label3, 0, 1, 2, 3,
              0, 0,
              0, 0);
      Set_Alignment (New_Auction_Win.Label3, 0.5, 0.5);
      Set_Padding (New_Auction_Win.Label3, 0, 0);
      Set_Justify (New_Auction_Win.Label3, Justify_Center);
      Set_Line_Wrap (New_Auction_Win.Label3, False);

      Gtk_New (New_Auction_Win.Name_Entry);
      Attach (New_Auction_Win.Table1, New_Auction_Win.Name_Entry, 1, 2, 0, 1,
              Expand or Fill, 0,
              5, 2);
      Set_Editable (New_Auction_Win.Name_Entry, True);
      Set_Max_Length (New_Auction_Win.Name_Entry, 0);
      Set_Text (New_Auction_Win.Name_Entry, "");
      Set_Visibility (New_Auction_Win.Name_Entry, True);

      Gtk_New (New_Auction_Win.Base_Bid_Entry);
      Attach (New_Auction_Win.Table1,
              New_Auction_Win.Base_Bid_Entry, 1, 2, 2, 3,
              Expand or Fill, 0,
              5, 2);
      Set_Editable (New_Auction_Win.Base_Bid_Entry, True);
      Set_Max_Length (New_Auction_Win.Base_Bid_Entry, 0);
      Set_Text (New_Auction_Win.Base_Bid_Entry, "");
      Set_Visibility (New_Auction_Win.Base_Bid_Entry, True);

      Gtk_New (New_Auction_Win.Frame1);
      Attach (New_Auction_Win.Table1, New_Auction_Win.Frame1, 1, 2, 1, 2,
              Fill, Fill,
              5, 7);
      Set_Shadow_Type (New_Auction_Win.Frame1, Shadow_Etched_In);

      Gtk_New (New_Auction_Win.Scrolledwindow1);
      Add (New_Auction_Win.Frame1,
           New_Auction_Win.Scrolledwindow1);
      Set_Policy (New_Auction_Win.Scrolledwindow1,
                  Policy_Never, Policy_Always);

      Gtk_New (New_Auction_Win.Description_Textbox);
      Add (New_Auction_Win.Scrolledwindow1,
           New_Auction_Win.Description_Textbox);
      Set_Editable (New_Auction_Win.Description_Textbox, True);

      Gtk_New_Hseparator (New_Auction_Win.Hseparator1);
      Pack_Start (New_Auction_Win.Vbox1,
                  New_Auction_Win.Hseparator1, True, True, 6);

      Gtk_New_Hbox (New_Auction_Win.Hbox1, False, 0);
      Pack_Start (New_Auction_Win.Vbox1,
                  New_Auction_Win.Hbox1, True, False, 0);

      Gtk_New (New_Auction_Win.Ok_B, "Submit");
      Pack_Start (New_Auction_Win.Hbox1,
                  New_Auction_Win.Ok_B, True, False, 0);
      Button_Callback.Connect
        (New_Auction_Win.Ok_B, "clicked",
         Button_Callback.To_Marshaller (On_Ok_B_Clicked'Access),
         New_Auction_Win_Access (New_Auction_Win));

      Gtk_New (New_Auction_Win.Cancel_B, "Cancel");
      Pack_Start (New_Auction_Win.Hbox1,
                  New_Auction_Win.Cancel_B, True, False, 0);
      Button_Callback.Connect
        (New_Auction_Win.Cancel_B, "clicked",
         Button_Callback.To_Marshaller (On_Cancel_B_Clicked'Access),
         New_Auction_Win_Access (New_Auction_Win));

      --  User defined
   end Initialize;

end New_Auction_Win_Pkg;
