with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Callbacks_Notenoughfunds; use Callbacks_Notenoughfunds;
with Notenoughfunds_Dialog_Pkg.Callbacks;
use Notenoughfunds_Dialog_Pkg.Callbacks;

package body Notenoughfunds_Dialog_Pkg is

   procedure Gtk_New (Notenoughfunds_Dialog : out Notenoughfunds_Dialog_Access)
   is
   begin
      Notenoughfunds_Dialog := new Notenoughfunds_Dialog_Record;
      Notenoughfunds_Dialog_Pkg.Initialize (Notenoughfunds_Dialog);
   end Gtk_New;

   procedure Initialize
     (Notenoughfunds_Dialog : access Notenoughfunds_Dialog_Record'Class) is
      The_Accel_Group : Gtk_Accel_Group;

   begin
      Gtk.Dialog.Initialize (Notenoughfunds_Dialog);
      Set_Title (Notenoughfunds_Dialog, "Warning: Overbid");
      Set_Policy (Notenoughfunds_Dialog, False, False, False);
      Set_Position (Notenoughfunds_Dialog, Win_Pos_Mouse);
      Set_Modal (Notenoughfunds_Dialog, False);

      Notenoughfunds_Dialog.Dialog_Vbox1 := Get_Vbox (Notenoughfunds_Dialog);
      Set_Homogeneous (Notenoughfunds_Dialog.Dialog_Vbox1, False);
      Set_Spacing (Notenoughfunds_Dialog.Dialog_Vbox1, 0);

      Gtk_New_Hbox (Notenoughfunds_Dialog.Hbox1, False, 2);
      Pack_Start (Notenoughfunds_Dialog.Dialog_Vbox1,
                  Notenoughfunds_Dialog.Hbox1, True, True, 0);
      Set_Border_Width (Notenoughfunds_Dialog.Hbox1, 1);

      Notenoughfunds_Dialog.Warning_Pixmap :=
        Create_Pixmap ("warning.xpm", Notenoughfunds_Dialog);
      Pack_Start (Notenoughfunds_Dialog.Hbox1,
                  Notenoughfunds_Dialog.Warning_Pixmap, True, True, 0);
      Set_USize (Notenoughfunds_Dialog.Warning_Pixmap, 41, 15);
      Set_Alignment (Notenoughfunds_Dialog.Warning_Pixmap, 0.5, 0.5);
      Set_Padding (Notenoughfunds_Dialog.Warning_Pixmap, 0, 0);

      Gtk_New (Notenoughfunds_Dialog.Label1,
               "Sorry, you have not enough funds." & ASCII.LF & "Try less.");
      Set_USize (Notenoughfunds_Dialog.Label1, 205, 48);
      Pack_Start (Notenoughfunds_Dialog.Hbox1,
                  Notenoughfunds_Dialog.Label1, False, False, 0);
      Set_Alignment (Notenoughfunds_Dialog.Label1, 0.5, 0.5);
      Set_Padding (Notenoughfunds_Dialog.Label1, 0, 0);
      Set_Justify (Notenoughfunds_Dialog.Label1, Justify_Center);
      Set_Line_Wrap (Notenoughfunds_Dialog.Label1, False);

      Notenoughfunds_Dialog.Dialog_Action_Area1 :=
        Get_Action_Area (Notenoughfunds_Dialog);
      Set_Border_Width (Notenoughfunds_Dialog.Dialog_Action_Area1, 4);
      Set_Homogeneous (Notenoughfunds_Dialog.Dialog_Action_Area1, True);
      Set_Spacing (Notenoughfunds_Dialog.Dialog_Action_Area1, 1);

      Gtk_New (Notenoughfunds_Dialog.Ok_Button, "OK");
      Set_Flags (Notenoughfunds_Dialog.Ok_Button, Can_Default);
      Set_Flags (Notenoughfunds_Dialog.Ok_Button, Can_Focus);

      Grab_Focus (Notenoughfunds_Dialog.Ok_Button);
      Grab_Default (Notenoughfunds_Dialog.Ok_Button);
      Pack_Start (Notenoughfunds_Dialog.Dialog_Action_Area1,
                  Notenoughfunds_Dialog.Ok_Button, False, False, 0);
      Set_USize (Notenoughfunds_Dialog.Ok_Button, 79, 33);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Notenoughfunds_Dialog, The_Accel_Group);
      Add_Accelerator (Notenoughfunds_Dialog.Ok_Button, "pressed",
                       The_Accel_Group, GDK_Return, 0, Accel_Visible);
      Button_Callback.Connect
        (Notenoughfunds_Dialog.Ok_Button, "pressed",
         Button_Callback.To_Marshaller (On_Ok_Button_Pressed'Access),
         Notenoughfunds_Dialog_Access (Notenoughfunds_Dialog));
   end Initialize;

end Notenoughfunds_Dialog_Pkg;
