with Gtk.Widget; use Gtk.Widget;
--  with Sell_Command_Types; use Sell_Command_Types;
with Debug_Auction;

package body Sell_Window_Pkg.Callbacks is

   use Gtk.Arguments;

   ---------------------------
   -- On_Bid_Window_Destroy --
   ---------------------------

   procedure On_Bid_Window_Destroy
     (Object : access Gtk_Window_Record'Class) is
   begin
      Timeout_Remove
        (Sell_Window_Access (Object) .My_Timeout_Handler_Id);
   end On_Bid_Window_Destroy;

   --------------------------------
   -- On_Bid_Window_Delete_Event --
   --------------------------------

   function On_Bid_Window_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean
   is
   begin
      return False;
   end On_Bid_Window_Delete_Event;

   ---------------------------
   -- On_Accept_Button_Pressed --
   ---------------------------

   procedure On_Accept_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      Sell_Win : Sell_Window_Access) is

      --  Accept_C : Accept_Command_Type;
   begin
      --  Sell_Win.Sell_Command_Buffer.Send (Accept_C);
      Accept_Bid (Sell_Win.Auction_Id, Sell_Win.User_Id);
      Timeout_Remove (Sell_Win.My_Timeout_Handler_Id);
      Destroy_Cb (Sell_Win);
   end On_Accept_Button_Pressed;

   function Update_Infos (Sell_Win : Sell_Window_Access) return Boolean is

      Current_Bid : Natural := Get_Current_Bid (Sell_Win.Auction_Id,
                                                Sell_Win.User_Id);
   begin
      Set_Text (Sell_Win.Current_Bid_Label, Natural'Image (Current_Bid));
      return True;
   end Update_Infos;

end Sell_Window_Pkg.Callbacks;
