with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;
with Callbacks_Sell_Win; use Callbacks_Sell_Win;
with Sell_Window_Pkg.Callbacks; use Sell_Window_Pkg.Callbacks;
with Debug_Auction;
with Gtk.Main; use Gtk.Main;
with Timeout_Sell_Window;

package body Sell_Window_Pkg is

   procedure Gtk_New (Sell_Window : out Sell_Window_Access;
                      User_Id : User_Identifier_Type;
                      Auction_Id : Auction_Identifier_Type)
   is
   begin
      Sell_Window := new Sell_Window_Record;
      Sell_Window.Auction_Id := Auction_Id;
      Sell_Window.User_Id := User_Id;
      Sell_Window_Pkg.Initialize (Sell_Window);
   end Gtk_New;

   procedure Initialize (Sell_Window : access Sell_Window_Record'Class) is
      The_Accel_Group : Gtk_Accel_Group;
--      T : Transaction;
   begin
      Gtk.Window.Initialize (Sell_Window, Window_Toplevel);

      Window_Callback.Connect
        (Sell_Window, "destroy",
         Window_Callback.To_Marshaller (On_Bid_Window_Destroy'Access));
      Return_Callback.Connect
        (Sell_Window, "delete_event", On_Bid_Window_Delete_Event'Access);

      Set_Policy (Sell_Window, False, False, False);
      Set_Position (Sell_Window, Win_Pos_None);
      Set_Modal (Sell_Window, False);

      Gtk_New (Sell_Window.Fixed1);
      Add (Sell_Window, Sell_Window.Fixed1);

      Gtk_New (Sell_Window.Frame8, "Description");
      Set_UPosition (Sell_Window.Frame8, 128, 8);
      Set_USize (Sell_Window.Frame8, 120, 88);
      Put (Sell_Window.Fixed1, Sell_Window.Frame8, 128, 8);
      Set_Shadow_Type (Sell_Window.Frame8, Shadow_Etched_In);

      Gtk_New (Sell_Window.Label4, Get_Description (Sell_Window.Auction_ID,
                                                    Sell_Window.User_Id));
      --  Gtk_New (Sell_Window.Label4, "A completer..");
      Add (Sell_Window.Frame8, Sell_Window.Label4);
      Set_Alignment (Sell_Window.Label4, 0.32, 0.5);
      Set_Padding (Sell_Window.Label4, 0, 0);
      Set_Justify (Sell_Window.Label4, Justify_Left);
      Set_Line_Wrap (Sell_Window.Label4, False);

      Gtk_New (Sell_Window.Frame4, "Opening Bid");
      Set_UPosition (Sell_Window.Frame4, 8, 56);
      Set_USize (Sell_Window.Frame4, 104, 40);
      Put (Sell_Window.Fixed1, Sell_Window.Frame4, 8, 56);
      Set_Shadow_Type (Sell_Window.Frame4, Shadow_Etched_In);

      Gtk_New (Sell_Window.Start_Bid_Label, Natural'Image
               (Get_Initial_Bid (Sell_Window.Auction_ID,
                                 Sell_Window.User_Id)));
     -- Gtk_New (Sell_Window.Start_Bid_Label, "??");
      Add (Sell_Window.Frame4, Sell_Window.Start_Bid_Label);
      Set_Alignment (Sell_Window.Start_Bid_Label, 0.5, 0.5);
      Set_Padding (Sell_Window.Start_Bid_Label, 0, 0);
      Set_Justify (Sell_Window.Start_Bid_Label, Justify_Center);
      Set_Line_Wrap (Sell_Window.Start_Bid_Label, False);

      Gtk_New (Sell_Window.Frame6, "Current Bid");
      Set_UPosition (Sell_Window.Frame6, 8, 104);
      Set_USize (Sell_Window.Frame6, 104, 40);
      Put (Sell_Window.Fixed1, Sell_Window.Frame6, 8, 104);
      Set_Shadow_Type (Sell_Window.Frame6, Shadow_Etched_In);

     --  Gtk_New (Sell_Window.Current_Bid_Label, Natural'Image
--                (Get_Current_Bid (Sell_Window.Auction.all)));
       Gtk_New (Sell_Window.Current_Bid_Label,
                   Natural'Image (Get_Current_Bid (Sell_Window.Auction_Id,
                                                   Sell_Window.User_Id)));
   --   Gtk_New (Sell_Window.Current_Bid_Label, "**");

      Add (Sell_Window.Frame6, Sell_Window.Current_Bid_Label);
      Set_Alignment (Sell_Window.Current_Bid_Label, 0.5, 0.5);
      Set_Padding (Sell_Window.Current_Bid_Label, 0, 0);
      Set_Justify (Sell_Window.Current_Bid_Label, Justify_Center);
      Set_Line_Wrap (Sell_Window.Current_Bid_Label, False);

      Gtk_New (Sell_Window.Frame7);
      Set_UPosition (Sell_Window.Frame7, 128, 111);
      Set_USize (Sell_Window.Frame7, 120, 33);
      Put (Sell_Window.Fixed1, Sell_Window.Frame7, 128, 111);
      Set_Shadow_Type (Sell_Window.Frame7, Shadow_Etched_In);

      Gtk_New (Sell_Window.Accept_Button, "Accept");
      Add (Sell_Window.Frame7, Sell_Window.Accept_Button);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Sell_Window, The_Accel_Group);
      Add_Accelerator (Sell_Window.Accept_Button, "pressed",
                       The_Accel_Group, GDK_Return, 0, Accel_Visible);
      Button_Callback.Connect
        (Sell_Window.Accept_Button, "pressed",
         Button_Callback.To_Marshaller (On_Accept_Button_Pressed'Access),
         Sell_Window_Access (Sell_Window));
      Set_Border_Width (Sell_Window.Accept_Button, 2);

      Gtk_New (Sell_Window.Frame5, "Title");
      Set_UPosition (Sell_Window.Frame5, 8, 8);
      Set_USize (Sell_Window.Frame5, 104, 40);
      Put (Sell_Window.Fixed1, Sell_Window.Frame5, 8, 8);
      Set_Shadow_Type (Sell_Window.Frame5, Shadow_Etched_In);

      declare
         S : String := Get_Name (Sell_Window.Auction_ID,
                                 Sell_Window.User_Id);
      begin
         --  Gtk_New (Sell_Window.Name_Label, "A remplir...");
         Gtk_New (Sell_Window.Name_Label, S);
         Add (Sell_Window.Frame5, Sell_Window.Name_Label);
         Set_Alignment (Sell_Window.Name_Label, 0.5, 0.5);
         Set_Padding (Sell_Window.Name_Label, 0, 0);
         Set_Justify (Sell_Window.Name_Label, Justify_Center);
         Set_Line_Wrap (Sell_Window.Name_Label, False);
         Set_Title (Sell_Window, "Seller: " & Get_Name (Sell_Window.User_Id) &
                    " Auction: " & S);
      end;

      Sell_Window.My_Timeout_Handler_Id :=
        Timeout_Sell_Window.Add (8000, Update_Infos'Access,
                                 Sell_Window_Access(Sell_Window));
   end Initialize;

end Sell_Window_Pkg;
