with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Callbacks_Login_Error; use Callbacks_Login_Error;
with Login_Error_Dialog_Pkg.Callbacks;
use Login_Error_Dialog_Pkg.Callbacks;

package body Login_Error_Dialog_Pkg is

   procedure Gtk_New (Login_Error_Dialog : out Login_Error_Dialog_Access)
   is
   begin
      Login_Error_Dialog := new Login_Error_Dialog_Record;
      Login_Error_Dialog_Pkg.Initialize (Login_Error_Dialog);
   end Gtk_New;

   procedure Initialize
     (Login_Error_Dialog : access Login_Error_Dialog_Record'Class) is
      The_Accel_Group : Gtk_Accel_Group;

   begin
      Gtk.Dialog.Initialize (Login_Error_Dialog);
      Set_Title (Login_Error_Dialog, "Warning: Overbid");
      Set_Policy (Login_Error_Dialog, False, False, False);
      Set_Position (Login_Error_Dialog, Win_Pos_Mouse);
      Set_Modal (Login_Error_Dialog, False);

      Login_Error_Dialog.Dialog_Vbox1 := Get_Vbox (Login_Error_Dialog);
      Set_Homogeneous (Login_Error_Dialog.Dialog_Vbox1, False);
      Set_Spacing (Login_Error_Dialog.Dialog_Vbox1, 0);

      Gtk_New_Hbox (Login_Error_Dialog.Hbox1, False, 2);
      Pack_Start (Login_Error_Dialog.Dialog_Vbox1,
                  Login_Error_Dialog.Hbox1, True, True, 0);
      Set_Border_Width (Login_Error_Dialog.Hbox1, 1);

      Login_Error_Dialog.Warning_Pixmap :=
        Create_Pixmap ("warning.xpm", Login_Error_Dialog);
      Pack_Start (Login_Error_Dialog.Hbox1,
                  Login_Error_Dialog.Warning_Pixmap, True, True, 0);
      Set_USize (Login_Error_Dialog.Warning_Pixmap, 41, 15);
      Set_Alignment (Login_Error_Dialog.Warning_Pixmap, 0.5, 0.5);
      Set_Padding (Login_Error_Dialog.Warning_Pixmap, 0, 0);

      Gtk_New (Login_Error_Dialog.Label1,
               "Login Error!" & ASCII.LF & "Check Login and Password.");
      Set_USize (Login_Error_Dialog.Label1, 205, 48);
      Pack_Start (Login_Error_Dialog.Hbox1,
                  Login_Error_Dialog.Label1, False, False, 0);
      Set_Alignment (Login_Error_Dialog.Label1, 0.5, 0.5);
      Set_Padding (Login_Error_Dialog.Label1, 0, 0);
      Set_Justify (Login_Error_Dialog.Label1, Justify_Center);
      Set_Line_Wrap (Login_Error_Dialog.Label1, False);

      Login_Error_Dialog.Dialog_Action_Area1 :=
        Get_Action_Area (Login_Error_Dialog);
      Set_Border_Width (Login_Error_Dialog.Dialog_Action_Area1, 4);
      Set_Homogeneous (Login_Error_Dialog.Dialog_Action_Area1, True);
      Set_Spacing (Login_Error_Dialog.Dialog_Action_Area1, 1);

      Gtk_New (Login_Error_Dialog.Ok_Button, "OK");
      Set_Flags (Login_Error_Dialog.Ok_Button, Can_Default);
      Set_Flags (Login_Error_Dialog.Ok_Button, Can_Focus);

      Grab_Focus (Login_Error_Dialog.Ok_Button);
      Grab_Default (Login_Error_Dialog.Ok_Button);
      Pack_Start (Login_Error_Dialog.Dialog_Action_Area1,
                  Login_Error_Dialog.Ok_Button, False, False, 0);
      Set_USize (Login_Error_Dialog.Ok_Button, 79, 33);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Login_Error_Dialog, The_Accel_Group);
      Add_Accelerator (Login_Error_Dialog.Ok_Button, "pressed",
                       The_Accel_Group, GDK_Return, 0, Accel_Visible);
      Button_Callback.Connect
        (Login_Error_Dialog.Ok_Button, "pressed",
         Button_Callback.To_Marshaller (On_Ok_Button_Pressed'Access),
         Login_Error_Dialog_Access (Login_Error_Dialog));
   end Initialize;

end Login_Error_Dialog_Pkg;
