--  with System; use System;
--  with Glib; use Glib;
with Gdk.Event; use Gdk.Event;
with Gdk.Types; use Gdk.Types;
--  with Gtk.Accel_Group; use Gtk.Accel_Group;
--  with Gtk.Object; use Gtk.Object;
with Gtk.Enums; use Gtk.Enums;
--  with Gtk.Style; use Gtk.Style;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Enums; use Gtk.Enums;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;
with Gdk.Types; use Gdk.Types;
with Gtk.Main; use Gtk.Main;
with Gtk.Button; use Gtk.Button;

with Gtk.Clist; use Gtk.Clist;
--  with Gtk.Scrolled_Window; use Gtk.Scrolled_Window;
--  with Gtkada.Handlers; use Gtkada.Handlers;

with Server_Interface; use Server_Interface;
with User_Interface; use User_Interface;

with Debug_Auction;
with New_User_Window_Pkg; use New_User_Window_Pkg;
with User_Win_Pkg; use User_Win_Pkg;
with Login_Error_Dialog_Pkg; use Login_Error_Dialog_Pkg;
--  with Debug_Window; use Debug_Window;

--  with Interface_Calls; use Interface_Calls;

--  with Transactional_Users;
--  use Transactional_Users;

--  with Transactional_Accounts;
--  use Transactional_Accounts;

--  with User_Tasks, User_Win_Pkg;
--  use User_Tasks, User_Win_Pkg;
--  with Command_Buffers; use Command_Buffers;

package body Login_Window_Pkg.Callbacks is

   use Gtk.Arguments;

   ------------------------------------
   -- On_Login_Window_Key_Press_Event --
   ------------------------------------

   function On_Login_Window_Key_Press_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean
   is
      Arg1 : Gdk_Event := To_Event (Params, 1);
   begin
      if (Get_Key_Val (Arg1) = GDK_Return) and then
        (Get_State (Login_Window) = State_Normal) then
         On_Login_Button_Pressed (Login_Window.Login_Button);
      end if;

      if Get_Key_Val (Arg1) = GDK_Escape and then
        (Get_State (Login_Window) = State_Normal) then
         Main_Quit;
      end if;
      return False;
   end On_Login_Window_Key_Press_Event;

   ----------------------------
   -- On_Login_Window_Destroy --
   ----------------------------

   procedure On_Login_Window_Destroy
     (Object : access Gtk_Window_Record'Class)
   is
   begin
      Main_Quit;
   end On_Login_Window_Destroy;

   ---------------------------------
   -- On_Login_Window_Delete_Event --
   ---------------------------------

   function On_Login_Window_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean
   is
      --  Arg1 : Gdk_Event := To_Event (Params, 1);
   begin
      return False;
   end On_Login_Window_Delete_Event;

   -----------------------------
   -- On_Login_Button_Pressed --
   -----------------------------

   procedure On_Login_Button_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
      U : User_Identifier_Type;
      --   User : Transactional_User_Ref;
      --       Account : Transactional_Account_Ref;
      --       New_User_Task : User_Task_Ref;
      User_Window : User_Win_Access;
      --       New_Command_Buffer : Command_Buffer_Ref;
   begin
      U := Server_Interface.Login (Get_Text (Login_Window.Name_Entry),
                                   Get_Text (Login_Window.Pass_Entry));
      User_Win_Pkg.Gtk_New (User_Window);
      User_Win_Pkg.Initialize (User_Window, U);
      Show_All (User_Window);
      Hide (Login_Window);
      --  Deposit (U, 500);
      -- if not Dask_Server.Login (Get_Text (Login_Window.Name_Entry),
      --                             Get_Text (Login_Window.Pass_Entry)) then
      --          Debug.Put_Line ("Client: Login Incorrect");
      --       else
      --          Debug.Put_Line ("Client: BINGO");
      --       end if;
      --    Debug_Put ("Checking Pass");
      --       if BCheck_Password (Get_Text (Login_Window.Name_Entry),
      --                              Get_Text (Login_Window.Pass_Entry))
      --       then
      --          Debug_Put ("Login Correct");
      --          User := BGet_User (Get_Text (Login_Window.Name_Entry),
      --                             Get_Text (Login_Window.Pass_Entry));
      --          Account := BGet_Account (User);
      --          New_Command_Buffer := new Command_Buffer_Type;
      --          User_Win_Pkg.Gtk_New (New_User_Window);
      --          User_Win_Pkg.Initialize (New_User_Window, User, Account,
      --                     New_Command_Buffer,
      --  Login_Window.Users_Logged + 1);
      --          New_User_Task := new User_Task_Type
      --  (Gtk_Window (New_User_Window),
      --                   User, New_Command_Buffer, Account);
      --          Login_Window.Users_Logged := Login_Window.Users_Logged + 1;
      --          Show_All (New_User_Window);
      --          Set_Text (Login_Window.Name_Entry, "");
      --          Set_Text (Login_Window.Pass_Entry, "");

      --          Debug_Put ("Login Incorrect");  --  Error Message

      --  end if;
   exception
      when Login_Incorrect =>
         declare
            Login_Error_Dialog : Login_Error_Dialog_Access;
         begin
            Gtk_New (Login_Error_Dialog);
            Show_All (Login_Error_Dialog);
            Debug_Auction.Put_Line ("ERROR: LOGIN INCORRECT");
            -- Set_Text (Login_Window.Name_Entry, "");
            Set_Text (Login_Window.Pass_Entry, "");
         end;
   end On_Login_Button_Pressed;

   --------------------------------
   -- On_New_User_Button_Pressed --
   --------------------------------

   procedure On_New_User_Button_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
      New_User_Window : New_User_Window_Access;
   begin
      Gtk_New (New_User_Window);
      Show_All (New_User_Window);
   end On_New_User_Button_Pressed;

   -----------------------------
   -- On_Users_Button_Pressed --
   -----------------------------
   function Hide_Users (Object : access Gtk_Widget_Record'Class;
                        Params : Gtk.Arguments.Gtk_Args) return Boolean;
   function Hide_Users
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean is
   begin
      --   Users_Visible := False;
      return False;
   end Hide_Users;

   procedure On_Users_Button_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
      --  Users_Win : Gtk_Window;
      --       Scroll : Gtk_Scrolled_Window;
   begin
      null;
      --  if Users_Visible then
      --          null;
      --       else
      --          Users_List := Bcreate_Users_List;
      --          Gtk_New (Users_Win);
      --          Set_Title (Users_Win, "");
      --          Set_USize (Users_Win, 140, 300);
      --          Set_UPosition (Users_Win, 90, 0);
      --          Gtk_New (Scroll);
      --          Return_Callback.Connect
      --            (Users_Win, "delete_event", Hide_Users'Access);
      --          Set_Border_Width (Scroll, 5);
      --          Set_Policy (Scroll, Policy_Automatic, Policy_Automatic);
      --          Users_List := BCreate_Users_List;
      --          Add (Scroll, Users_List);
      --          Add (Users_Win, Scroll);
      --          Show_All (Users_Win);
      --          Users_Visible := True;
      --       end if;
      --    exception
      --       when others =>
      --          Debug_Put ("No Users Yet!"); -- error message
   end On_Users_Button_Pressed;

   ----------------------------
   -- On_Quit_Button_Pressed --
   ----------------------------

   procedure On_Quit_Button_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      --  Main_Quit;
      Gtk_Exit (0);
   end On_Quit_Button_Pressed;

end Login_Window_Pkg.Callbacks;
