--  with Glib; use Glib;
with Gtk; use Gtk;
--  with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Login; use Callbacks_Login;
with Login_Window_Pkg.Callbacks; use Login_Window_Pkg.Callbacks;

package body Login_Window_Pkg is

   procedure Gtk_New (Login_Window : out Login_Window_Access) is
   begin
      Login_Window := new Login_Window_Record;
      Login_Window_Pkg.Initialize (Login_Window);
   end Gtk_New;

   procedure Initialize (Login_Window : access Login_Window_Record'Class) is
   begin
      Gtk.Window.Initialize (Login_Window, Window_Toplevel);
      Return_Callback.Connect
        (Login_Window, "key_press_event",
         On_Login_Window_Key_Press_Event'Access);
      Window_Callback.Connect
        (Login_Window, "destroy",
         Window_Callback.To_Marshaller (On_Login_Window_Destroy'Access));
      Return_Callback.Connect
        (Login_Window, "delete_event", On_Login_Window_Delete_Event'Access);
      Set_Title (Login_Window, "Login");
      Set_Policy (Login_Window, False, False, False);
      --  Set_Position (Login_Window, Win_Pos_None);
      Set_UPosition (Login_Window, 765, 515);
      Set_Modal (Login_Window, False);

      Gtk_New_Vbox (Login_Window.Vbox1, False, 0);
      Add (Login_Window, Login_Window.Vbox1);

      Gtk_New (Login_Window.Frame3, "Login Information");
      Pack_Start (Login_Window.Vbox1, Login_Window.Frame3, True, True, 6);
      Set_Border_Width (Login_Window.Frame3, 3);
      Set_Shadow_Type (Login_Window.Frame3, Shadow_Etched_In);

      Gtk_New_Vbox (Login_Window.Vbox3, False, 0);
      Add (Login_Window.Frame3, Login_Window.Vbox3);

      Gtk_New_Hbox (Login_Window.Hbox2, False, 0);
      Pack_Start (Login_Window.Vbox3, Login_Window.Hbox2, True, True, 0);
      Set_Border_Width (Login_Window.Hbox2, 5);

      Gtk_New (Login_Window.Label1, "Username : ");
      Pack_Start (Login_Window.Hbox2, Login_Window.Label1, True, False, 0);
      Set_Alignment (Login_Window.Label1, 0.5, 0.5);
      Set_Padding (Login_Window.Label1, 0, 0);
      Set_Justify (Login_Window.Label1, Justify_Right);
      Set_Line_Wrap (Login_Window.Label1, False);

      Gtk_New (Login_Window.Name_Entry);
      Set_Flags (Login_Window.Name_Entry, Can_Focus);
      Pack_Start (Login_Window.Hbox2, Login_Window.Name_Entry, True, True, 0);
      Grab_Focus (Login_Window.Name_Entry);
      Set_Editable (Login_Window.Name_Entry, True);
      Set_Max_Length (Login_Window.Name_Entry, 20);
      Set_Text (Login_Window.Name_Entry, "");
      Set_Visibility (Login_Window.Name_Entry, True);

      Gtk_New_Hbox (Login_Window.Hbox3, False, 0);
      Pack_Start (Login_Window.Vbox3, Login_Window.Hbox3, True, True, 0);
      Set_Border_Width (Login_Window.Hbox3, 5);

      Gtk_New (Login_Window.Label2, "Password :  ");
      Pack_Start (Login_Window.Hbox3, Login_Window.Label2, True, False, 0);
      Set_Alignment (Login_Window.Label2, 0.5, 0.5);
      Set_Padding (Login_Window.Label2, 0, 0);
      Set_Justify (Login_Window.Label2, Justify_Center);
      Set_Line_Wrap (Login_Window.Label2, False);

      Gtk_New (Login_Window.Pass_Entry);
      Pack_Start (Login_Window.Hbox3, Login_Window.Pass_Entry, True, True, 0);
      Set_Editable (Login_Window.Pass_Entry, True);
      Set_Max_Length (Login_Window.Pass_Entry, 20);
      Set_Text (Login_Window.Pass_Entry, "");
      Set_Visibility (Login_Window.Pass_Entry, False);

      Gtk_New_Hseparator (Login_Window.Hseparator1);
      Pack_Start (Login_Window.Vbox1,
                  Login_Window.Hseparator1, False, True, 5);

      Gtk_New_Hbox (Login_Window.Hbox1, False, 8);
      Pack_Start (Login_Window.Vbox1, Login_Window.Hbox1, True, True, 0);
      Set_Border_Width (Login_Window.Hbox1, 3);

      Gtk_New (Login_Window.Frame2);
      Pack_Start (Login_Window.Hbox1, Login_Window.Frame2, False, False, 0);
      Set_Shadow_Type (Login_Window.Frame2, Shadow_Etched_In);

      Gtk_New_Vbox (Login_Window.Vbox2, False, 7);
      Add (Login_Window.Frame2, Login_Window.Vbox2);
      Set_Border_Width (Login_Window.Vbox2, 6);

      Gtk_New (Login_Window.New_User_Button, "New User");
      Pack_Start (Login_Window.Vbox2,
                  Login_Window.New_User_Button, False, False, 0);
      Button_Callback.Connect
        (Login_Window.New_User_Button, "pressed",
         Button_Callback.To_Marshaller (On_New_User_Button_Pressed'Access));

      Gtk_New_Hbox (Login_Window.Hbox5, True, 0);
      Pack_Start (Login_Window.Vbox2, Login_Window.Hbox5, True, False, 0);

      Gtk_New (Login_Window.Users_Button, "Help");
      Pack_Start (Login_Window.Hbox5,
                  Login_Window.Users_Button, True, True, 4);
      Button_Callback.Connect
        (Login_Window.Users_Button, "pressed",
         Button_Callback.To_Marshaller (On_Users_Button_Pressed'Access));

      Gtk_New (Login_Window.Quit_Button, "Quit");
      Pack_Start (Login_Window.Hbox5, Login_Window.Quit_Button, True, True, 3);
      Button_Callback.Connect
        (Login_Window.Quit_Button, "pressed",
         Button_Callback.To_Marshaller (On_Quit_Button_Pressed'Access));

      Gtk_New (Login_Window.Login_Button, "Login");
      Set_Flags (Login_Window.Login_Button, Can_Default);
      Pack_Start (Login_Window.Hbox1,
                  Login_Window.Login_Button, True, True, 9);
      Grab_Default (Login_Window.Login_Button);
      Button_Callback.Connect
        (Login_Window.Login_Button, "pressed",
         Button_Callback.To_Marshaller (On_Login_Button_Pressed'Access));
      Set_Border_Width (Login_Window.Login_Button, 11);

   end Initialize;

end Login_Window_Pkg;
