with Glib; use Glib;
with Gdk.Event; use Gdk.Event;
with Gdk.Types; use Gdk.Types;
with Gtk.Widget; use Gtk.Widget;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;
--  with Main_Window_Pkg.Callbacks; use Main_Window_Pkg.Callbacks;
with Server_Interface;
with Debug_Auction;
with Gtk.Clist; use Gtk.Clist;
with Gtkada.Types; use Gtkada.Types;

package body New_User_Window_Pkg.Callbacks is

   use Gtk.Arguments;

   ----------------------------------------
   -- On_New_User_Window_Key_Press_Event --
   ----------------------------------------

   function On_New_User_Window_Key_Press_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args; -- ) return Boolean
      New_User_Window : New_User_Window_Access) return Boolean
   is
      Arg1 : Gdk_Event := To_Event (Params, 1);
   begin
      if Get_Key_Val (Arg1) = GDK_Return then
         On_Ok_Button_Pressed (New_User_Window.Ok_Button, New_User_Window);
      end if;
      if Get_Key_Val (Arg1) = GDK_Escape then
         On_Cancel_Button_Pressed (New_User_Window.Cancel_Button,
                                   New_User_Window);
      end if;
      return False;
   end On_New_User_Window_Key_Press_Event;

   -- On_New_User_Window_Destroy --
   --------------------------------

   procedure On_New_User_Window_Destroy
     (Object : access Gtk_Window_Record'Class;
      New_User_Window : New_User_Window_Access)
   is
   begin
      Destroy_Cb (New_User_Window);
   end On_New_User_Window_Destroy;

   -------------------------------------
   -- On_New_User_Window_Delete_Event --
   -------------------------------------

   function On_New_User_Window_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return boolean
      --  New_User_Window : New_User_Window_Access) return Boolean
   is
   begin
      return True;
   end On_New_User_Window_Delete_Event;

   ------------------------------
   -- On_Cancel_Button_Pressed --
   ------------------------------

   procedure On_Cancel_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      New_User_Window : New_User_Window_Access)
   is
   begin
      Destroy_Cb (New_User_Window);
   end On_Cancel_Button_Pressed;

   ----------------------------
   -- On_Help_Button_Pressed --
   ----------------------------

   procedure On_Help_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      New_User_Window : New_User_Window_Access)
   is
   begin
      null;
   end On_Help_Button_Pressed;

   --------------------------
   -- On_Ok_Button_Pressed --
   --------------------------

   procedure On_Ok_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      New_User_Window : New_User_Window_Access)
   is
      function Is_Ready return Boolean;
      function Is_Ready return Boolean is
      begin
         return Get_Text (New_User_Window.Name_Entry) /= "" and then
           (Get_Text (New_User_Window.Pass_Entry) =
            Get_Text (New_User_Window.Pass_Entry2));
      end Is_Ready;
      -- Index : Gint;
   begin
      if Is_Ready then
         Server_Interface.New_User
           (Get_Text (New_User_Window.Name_Entry),
            Get_Text (New_User_Window.Pass_Entry));
         Destroy_Cb (New_User_Window);
        --  if Users_Visible then
--             Index :=
--               Append (Users_List,
--                       Get_Text (New_User_Window.Name_Entry) + "");
--          end if;
      else
         Debug_Auction.Put_Line ("Fields incorrect");
      end if;

   end On_Ok_Button_Pressed;

end New_User_Window_Pkg.Callbacks;
