with Gtk; use Gtk;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_New_User; use Callbacks_New_User;
with New_User_Window_Pkg.Callbacks; use New_User_Window_Pkg.Callbacks;

package body New_User_Window_Pkg is

   procedure Gtk_New (New_User_Window : out New_User_Window_Access) is
   begin
      New_User_Window := new New_User_Window_Record;
      New_User_Window_Pkg.Initialize (New_User_Window);
   end Gtk_New;

   procedure Initialize
     (New_User_Window : access New_User_Window_Record'Class) is
   begin
      Gtk.Window.Initialize (New_User_Window, Window_Toplevel);

     --  Return_Callback.Connect
--         (New_User_Window,
--          "key_press_event",
--          Window_Callback.To_Marshaller (On_New_User_Window_Key_Press_Event'Access),
--                 New_User_Window_Access (New_User_Window));
      Widg_Callback.Connect
        (New_User_Window, "key_press_event",
         On_New_User_Window_Key_Press_Event'Access,
         New_User_Window_Access (New_User_Window));

      Window_Callback.Connect
        (New_User_Window,
         "destroy",
         Window_Callback.To_Marshaller (On_New_User_Window_Destroy'Access),
         New_User_Window_Access (New_User_Window));
      Return_Callback.Connect
        (New_User_Window,
         "delete_event",
         On_New_User_Window_Delete_Event'Access);

      Set_Title (New_User_Window, "New People Welcome!");
      Set_Policy (New_User_Window, True, True, True);
      Set_UPosition (New_User_Window, 150, 50);
      Set_Modal (New_User_Window, False);

      Gtk_New_Vbox (New_User_Window.Vbox1, False, 0);
      Add (New_User_Window, New_User_Window.Vbox1);

      Gtk_New (New_User_Window.Frame3);
      Pack_Start (New_User_Window.Vbox1,
                  New_User_Window.Frame3, True, True, 0);
      Set_Border_Width (New_User_Window.Frame3, 3);
      Set_Shadow_Type (New_User_Window.Frame3, Shadow_Etched_In);

      Gtk_New_Vbox (New_User_Window.Vbox3, False, 0);
      Add (New_User_Window.Frame3, New_User_Window.Vbox3);

      Gtk_New_Hbox (New_User_Window.Hbox2, False, 0);
      Pack_Start (New_User_Window.Vbox3, New_User_Window.Hbox2, True, True, 0);
      Set_Border_Width (New_User_Window.Hbox2, 5);

      Gtk_New (New_User_Window.Label1, "Username : ");
      Pack_Start (New_User_Window.Hbox2,
                  New_User_Window.Label1, True, False, 0);
      Set_Alignment (New_User_Window.Label1, 0.5, 0.5);
      Set_Padding (New_User_Window.Label1, 0, 0);
      Set_Justify (New_User_Window.Label1, Justify_Right);
      Set_Line_Wrap (New_User_Window.Label1, False);

      Gtk_New (New_User_Window.Name_Entry);
      Set_Flags (New_User_Window.Name_Entry, Can_Focus);
      Pack_Start (New_User_Window.Hbox2,
                  New_User_Window.Name_Entry, True, True, 0);
      Grab_Focus (New_User_Window.Name_Entry);
      Set_Editable (New_User_Window.Name_Entry, True);
      Set_Max_Length (New_User_Window.Name_Entry, 20);
      Set_Text (New_User_Window.Name_Entry, "");
      Set_Visibility (New_User_Window.Name_Entry, True);

      Gtk_New_Hbox (New_User_Window.Hbox3, False, 0);
      Pack_Start (New_User_Window.Vbox3,
                  New_User_Window.Hbox3, True, True, 0);
      Set_Border_Width (New_User_Window.Hbox3, 5);

      Gtk_New (New_User_Window.Label2, "Password :  ");
      Pack_Start (New_User_Window.Hbox3,
                  New_User_Window.Label2, True, False, 0);
      Set_Alignment (New_User_Window.Label2, 0.5, 0.5);
      Set_Padding (New_User_Window.Label2, 0, 0);
      Set_Justify (New_User_Window.Label2, Justify_Center);
      Set_Line_Wrap (New_User_Window.Label2, False);

      Gtk_New (New_User_Window.Pass_Entry);
      Pack_Start (New_User_Window.Hbox3,
                  New_User_Window.Pass_Entry, True, True, 0);
      Set_Editable (New_User_Window.Pass_Entry, True);
      Set_Max_Length (New_User_Window.Pass_Entry, 20);
      Set_Text (New_User_Window.Pass_Entry, "");
      Set_Visibility (New_User_Window.Pass_Entry, False);

      Gtk_New_Hbox (New_User_Window.Hbox6, False, 0);
      Pack_Start (New_User_Window.Vbox3,
                  New_User_Window.Hbox6, True, True, 0);
      Set_Border_Width (New_User_Window.Hbox6, 5);

      Gtk_New (New_User_Window.Label3, "Re-Type    : ");
      Pack_Start (New_User_Window.Hbox6,
                  New_User_Window.Label3, True, False, 0);
      Set_Alignment (New_User_Window.Label3, 0.5, 0.5);
      Set_Padding (New_User_Window.Label3, 0, 0);
      Set_Justify (New_User_Window.Label3, Justify_Center);
      Set_Line_Wrap (New_User_Window.Label3, False);

      Gtk_New (New_User_Window.Pass_Entry2);
      Pack_Start (New_User_Window.Hbox6,
                  New_User_Window.Pass_Entry2, True, True, 0);
      Set_Editable (New_User_Window.Pass_Entry2, True);
      Set_Max_Length (New_User_Window.Pass_Entry2, 20);
      Set_Text (New_User_Window.Pass_Entry2, "");
      Set_Visibility (New_User_Window.Pass_Entry2, False);

      Gtk_New_Hseparator (New_User_Window.Hseparator1);
      Pack_Start (New_User_Window.Vbox1,
                  New_User_Window.Hseparator1, False, True, 5);

      Gtk_New_Hbox (New_User_Window.Hbox1, False, 8);
      Pack_Start (New_User_Window.Vbox1, New_User_Window.Hbox1, True, True, 0);
      Set_Border_Width (New_User_Window.Hbox1, 3);

      Gtk_New (New_User_Window.Frame2);
      Pack_Start (New_User_Window.Hbox1,
                  New_User_Window.Frame2, False, False, 0);
      Set_Shadow_Type (New_User_Window.Frame2, Shadow_Etched_In);

      Gtk_New_Vbox (New_User_Window.Vbox2, False, 7);
      Add (New_User_Window.Frame2, New_User_Window.Vbox2);
      Set_Border_Width (New_User_Window.Vbox2, 2);

      Gtk_New (New_User_Window.Cancel_Button, "Cancel");
      Pack_Start (New_User_Window.Vbox2,
                  New_User_Window.Cancel_Button, True, False, 3);
      Button_Callback.Connect
        (New_User_Window.Cancel_Button, "pressed",
         Button_Callback.To_Marshaller (On_Cancel_Button_Pressed'Access),
         New_User_Window_Access (New_User_Window));
      Set_Border_Width (New_User_Window.Cancel_Button, 3);

      Gtk_New (New_User_Window.Help_Button, "Help");
      Pack_Start (New_User_Window.Vbox2,
                  New_User_Window.Help_Button, True, False, 0);
      Button_Callback.Connect
        (New_User_Window.Help_Button, "pressed",
         Button_Callback.To_Marshaller (On_Help_Button_Pressed'Access),
         New_User_Window_Access (New_User_Window));
      Set_Border_Width (New_User_Window.Help_Button, 3);

      Gtk_New (New_User_Window.Ok_Button, "Create my Account");
      Pack_Start (New_User_Window.Hbox1,
                  New_User_Window.Ok_Button, True, True, 9);
      Button_Callback.Connect
        (New_User_Window.Ok_Button, "pressed",
         Button_Callback.To_Marshaller (On_Ok_Button_Pressed'Access),
         New_User_Window_Access (New_User_Window));
      Set_Border_Width (New_User_Window.Ok_Button, 11);

   end Initialize;

end New_User_Window_Pkg;
