with Glib; use Glib;
with Gtk.Label; use Gtk.Label;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Main; use Gtk.Main;
with User_Win_Pkg; use User_Win_Pkg;
with New_Auction_Win_Pkg; use New_Auction_Win_Pkg;
with Bid_Window_Pkg; use Bid_Window_Pkg;
--  with Seller_Auction_Tasks; use Seller_Auction_Tasks;
--  with Buyer_Auction_Tasks; use Buyer_Auction_Tasks;
--  with Auction_Lists; use Auction_Lists;
--  with Transactional_Auctions; use Transactional_Auctions;
--  with Transaction_OO_Interface; use Transaction_OO_Interface;
with Debug_Auction;
with Auction_Interface; use Auction_Interface;
with Remote_String_Arrays; use Remote_String_Arrays;
with Server_Interface; use Server_Interface;
with Gtkada.Types; use Gtkada.Types;
--  with Ada.Text_IO; use Ada.Text_IO;

--  with User_Command_Types; use User_Command_Types;

package body User_Win_Pkg.Callbacks is

   use Gtk.Arguments;

   ------------------------------
   -- On_User_Win_Delete_Event --
   ------------------------------

   function On_User_Win_Delete_Event
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args) return Boolean
   is
   begin
      Gtk_Exit (0);
      return False;
   end On_User_Win_Delete_Event;

   -------------------------
   -- On_User_Win_Destroy --
   -------------------------

   procedure On_User_Win_Destroy
     (Object : access Gtk_Window_Record'Class)
   is
   begin
      Destroy_Cb (Object);
   end On_User_Win_Destroy;

   ---------------------------------
   -- On_Auctions_List_Select_Row --
   ---------------------------------

   procedure On_Auctions_List_Select_Row
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args;
      User_Win : User_Win_Access)
   is
      Infos : Auction_Infos_Ref;
      Arg1 : Gint := To_Gint (Params, 1);

      -- List : Auction_Array_Type := The_Auctions.Get_All_Auctions;
      -- Selected : Transactional_Auction_Ref := List (Integer (Arg1 + 1));
     -- T : Transaction;
   begin
      Free (User_Win.Title_Selected);
      User_Win.Title_Selected := new String'(Get_Text
                                             (User_Win.Auctions_List, Arg1,0));
      Set_Text (User_Win.Name_Label, User_Win.Title_Selected.all);
      Infos := Find (User_Win.The_Auctions, User_Win.Title_Selected.all);
      if not Infos.Loaded then
         Infos.Description := new String'(Get_Description (Infos.Id, User_Win.User_Id));
         Infos.Initial_Bid := Get_Initial_Bid (Infos.Id, User_Win.User_Id);
         Infos.Loaded := True;
         Debug_Auction.Put_Line ("Auction infos not in CACHE...");

      end if;
      Set_Text (User_Win.Description_Label, Infos.Description.all);
      Set_Text (User_Win.Start_Bid_Label, Natural'Image (Infos.Initial_Bid));
      Set_Text (User_Win.Current_Bid_Label,
                Natural'Image (Get_Current_Bid (Infos.Id, User_Win.User_Id)));

      Debug_Auction.Put_Line ("Auction called: " & User_Win.Title_Selected.all & " was selected");

   --    Debug_Put (Natural'Image (Get_Initial_Bid (Selected.all)));

      --  Set_Text (User_Win.Current_Bid_Label,
      --                 Natural'Image (Get_Current_Bid (Selected.all)));
      --       Set_Text (User_Win.Description_Label,
      --                 Get_Description (Selected.all));
      --       Set_Text (User_Win.Name_Label,
      --                 Get_Name (Selected.all));
      Set_Text (User_Win.Name_Label, User_Win.Title_Selected.all);
      --  Set_Text (User_Win.Start_Bid_Label,
      --                 Natural'Image (Get_Initial_Bid (Selected.all)));
      --       Commit_Transaction (T);
      Set_Sensitive (User_Win.Bid_Button, True);
      --       User_Win.Selected := Selected;
   exception
      when No_Such_Key =>
         Debug_Auction.Put_Line ("Exception: the item selected is not in the list!!");
         raise;
   end On_Auctions_List_Select_Row;

   ---------------------------
   -- On_Bid_Button_Pressed --
   ---------------------------

   procedure On_Bid_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access)
   is
      Bid_Window : Bid_Window_Access;
      Auction_Id : Auction_Identifier_Type;
      --  Buyer_Auction_Task : Buyer_Auction_Task_Ref;
   begin
      Auction_Id := Join_Auction (User_Win.User_ID, User_Win.Title_Selected.all);
      Gtk_New (Bid_Window, User_Win.User_ID, Auction_Id);
      Show_All (Bid_Window);
      Cosmetics (Bid_Window);

     --  Buyer_Auction_Task :=
--        new Buyer_Auction_Task_Type (User_Win.User, User_Win.Selected);
   end On_Bid_Button_Pressed;

   -------------------------------
   -- On_Deposit_Button_Pressed --
   -------------------------------

   procedure On_Deposit_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access)
   is
      --  Deposit : Deposit_Command_Type;
   begin
      Deposit (User_Win.User_ID, 50);
      Set_Text (Gtk_Label (User_Win.Balance_Label),
                Natural'Image (Balance (User_Win.User_ID)));
      --  Deposit.Value := 10;
      --  User_Win.User_Command_Buffer.Send (Deposit);
   end On_Deposit_Button_Pressed;

   -----------------------------------
   -- On_New_Auction_Button_Pressed --
   -----------------------------------

   procedure On_New_Auction_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access)
   is
      --  New_Command_Buffer : Command_Buffer_Ref;
      --  New_Seller_Auction_Task : Seller_Auction_Task_Ref;
      Creation_Auction_Window : New_Auction_Win_Access;
   begin
      Gtk_New (Creation_Auction_Window, User_Win.User_Id);
      Show_All (Creation_Auction_Window);

      -- New_Seller_Auction_Task :=
        --  New Seller_Auction_Task_Type (User_Win.User);
      --  New_Seller_Auction_Task.Bidon;
   end On_New_Auction_Button_Pressed;

   ------------------------------
   -- On_Cancel_Button_Pressed --
   ------------------------------

   procedure On_Cancel_Button_Pressed
     (Object : access Gtk_Button_Record'Class;
      User_Win : User_Win_Access)
   is
      --  Quit : Quit_Command_Type;
   begin
      Destroy_Cb (User_Win);
      Gtk_Exit (0);
      --  User_Win.User_Command_Buffer.Send (Quit);
   end On_Cancel_Button_Pressed;

   function Update_Infos (User_Win : User_Win_Access) return Boolean is
      Auctions_Array : Remote_String_Array_Type := Get_Current_Auction_List;
      Index : Gint;
      Infos : Auction_Infos_Ref;
   begin
      Freeze (User_Win.Auctions_List);
      Clear (User_Win.Auctions_List);
      for I in 1 .. Auctions_Array.Elements'Length loop
         begin
            Infos := Find (User_Win.The_Auctions, Auctions_Array.Elements (I).S);
         exception
            when No_Such_Key =>
               Infos := new Auction_Infos;
               Infos.Id := Auctions_Array.ids (I);
               Insert_Element (User_Win.The_Auctions,
                               Auctions_Array.Elements (I).S,
                               Infos);
         end;

         Index := Gtk.Clist.Append
           (User_Win.Auctions_List, Auctions_Array.Elements (I).S + "");
      end loop;
      Thaw (User_Win.Auctions_List);
      Set_Text (Gtk_Label (User_Win.Balance_Label),
                Natural'Image (Balance (User_Win.User_ID)));
      return True;
   end Update_Infos;

end User_Win_Pkg.Callbacks;
