with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gdk.Types.Keysyms; use Gdk.Types.Keysyms;
with Callbacks_User_Window; use Callbacks_User_Window;
with User_Win_Pkg.Callbacks; use User_Win_Pkg.Callbacks;
-- with Interface_Calls; use Interface_Calls;
-- with Transaction_OO_Interface; use Transaction_OO_Interface;
with Remote_String_Arrays; use Remote_String_Arrays;
with Server_Interface; use Server_Interface;
with Gtk.Main; use Gtk.Main;
with Timeout_User_Win;
with Gtkada.Types; use Gtkada.Types;

package body User_Win_Pkg is

   procedure Gtk_New (User_Win : out User_Win_Access) is
   begin
      User_Win := new User_Win_Record;
   end Gtk_New;

   procedure Initialize (User_Win : access User_Win_Record'Class;
                         User_ID : User_Identifier_Type) is

      The_Accel_Group : Gtk_Accel_Group;
      Index : Gint;
       My_Timeout_Handler_Id : Timeout_Handler_Id;
   begin
      Gtk.Window.Initialize (User_Win, Window_Toplevel);
      Return_Callback.Connect
        (User_Win, "delete_event", On_User_Win_Delete_Event'Access);
      Window_Callback.Connect
        (User_Win, "destroy",
         Window_Callback.To_Marshaller (On_User_Win_Destroy'Access));

      Set_Policy (User_Win, False, False, True);
      Set_Position (User_Win, Win_Pos_None);
      declare
         X_Pos : Gint := Gint ((User_ID - 1)*330 + 1);
      begin
         Set_UPosition (User_Win, X_Pos, 400);
      end;
      Set_Modal (User_Win, False);
      User_Win.User_ID := User_ID;
--       User_Win.Account := Account;
--       User_Win.User_Command_Buffer := Command_Buffer;

      Gtk_New_Vbox (User_Win.Vbox2, False, 0);
      Add (User_Win, User_Win.Vbox2);

      Gtk_New (User_Win.Frame12, "Auctions List");
      Pack_Start (User_Win.Vbox2, User_Win.Frame12, True, True, 0);
      Set_Border_Width (User_Win.Frame12, 3);
      Set_Shadow_Type (User_Win.Frame12, Shadow_Etched_In);

      Gtk_New (User_Win.Scrolledwindow1);
      Add (User_Win.Frame12, User_Win.Scrolledwindow1);
      Set_Border_Width (User_Win.Scrolledwindow1, 2);
      Set_Policy (User_Win.Scrolledwindow1, Policy_Never, Policy_Always);

      Gtk_New (User_Win.Auctions_List, 1);
      C_List_Callback.Connect
        (User_Win.Auctions_List, "select_row",
         On_Auctions_List_Select_Row'Access, User_Win_Access (User_Win));
      Add (User_Win.Scrolledwindow1, User_Win.Auctions_List);
      Set_Selection_Mode (User_Win.Auctions_List, Selection_Single);
      Set_Shadow_Type (User_Win.Auctions_List, Shadow_Etched_In);
      Set_Show_Titles (User_Win.Auctions_List, False);
      Set_Column_Width (User_Win.Auctions_List, 0, 80);

      Gtk_New (User_Win.Frame8, "Auction Info");
      Pack_Start (User_Win.Vbox2, User_Win.Frame8, True, True, 0);
      Set_Border_Width (User_Win.Frame8, 3);
      Set_Shadow_Type (User_Win.Frame8, Shadow_Etched_In);

      Gtk_New (User_Win.Fixed1);
      Add (User_Win.Frame8, User_Win.Fixed1);

      Gtk_New (User_Win.Bid_Button, "Place Bid");
      Set_Sensitive (User_Win.Bid_Button, False);
      Set_UPosition (User_Win.Bid_Button, 208, 8);
      Set_USize (User_Win.Bid_Button, 93, 30);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (User_Win, The_Accel_Group);
      Add_Accelerator (User_Win.Bid_Button, "pressed",
                       The_Accel_Group, GDK_B, 0, Accel_Visible);
      Button_Callback.Connect
        (User_Win.Bid_Button,
         "pressed",
         Button_Callback.To_Marshaller (On_Bid_Button_Pressed'Access),
         User_Win_Access (User_Win));
      Put (User_Win.Fixed1, User_Win.Bid_Button, 208, 8);
      Set_Border_Width (User_Win.Bid_Button, 3);

      Gtk_New (User_Win.Frame15, "Title");
      Set_UPosition (User_Win.Frame15, 8, 8);
      Set_USize (User_Win.Frame15, 176, 40);
      Put (User_Win.Fixed1, User_Win.Frame15, 8, 8);
      Set_Shadow_Type (User_Win.Frame15, Shadow_Etched_In);

      Gtk_New (User_Win.Name_Label);
      Add (User_Win.Frame15, User_Win.Name_Label);
      Set_Alignment (User_Win.Name_Label, 0.1, 0.5);
      Set_Padding (User_Win.Name_Label, 0, 0);
      Set_Justify (User_Win.Name_Label, Justify_Left);
      Set_Line_Wrap (User_Win.Name_Label, False);

      Gtk_New (User_Win.Frame16, "Opening Bid");
      Set_UPosition (User_Win.Frame16, 192, 48);
      Set_USize (User_Win.Frame16, 112, 48);
      Put (User_Win.Fixed1, User_Win.Frame16, 192, 48);
      Set_Border_Width (User_Win.Frame16, 3);
      Set_Shadow_Type (User_Win.Frame16, Shadow_Etched_In);

      Gtk_New (User_Win.Start_Bid_Label);
      Add (User_Win.Frame16, User_Win.Start_Bid_Label);
      Set_Alignment (User_Win.Start_Bid_Label, 0.2, 0.5);
      Set_Padding (User_Win.Start_Bid_Label, 0, 0);
      Set_Justify (User_Win.Start_Bid_Label, Justify_Right);
      Set_Line_Wrap (User_Win.Start_Bid_Label, True);

      Gtk_New (User_Win.Frame14, "Description");
      Set_UPosition (User_Win.Frame14, 8, 56);
      Set_USize (User_Win.Frame14, 176, 84);
      Put (User_Win.Fixed1, User_Win.Frame14, 8, 56);
      Set_Shadow_Type (User_Win.Frame14, Shadow_Etched_In);

      Gtk_New (User_Win.Description_Label);
      Add (User_Win.Frame14, User_Win.Description_Label);
      Set_Alignment (User_Win.Description_Label, 0.1, 0.5);
      Set_Padding (User_Win.Description_Label, 0, 0);
      Set_Justify (User_Win.Description_Label, Justify_Left);
      Set_Line_Wrap (User_Win.Description_Label, False);

      Gtk_New (User_Win.Frame17, "Current Bid");
      Set_UPosition (User_Win.Frame17, 192, 96);
      Set_USize (User_Win.Frame17, 112, 48);
      Put (User_Win.Fixed1, User_Win.Frame17, 192, 96);
      Set_Border_Width (User_Win.Frame17, 3);
      Set_Shadow_Type (User_Win.Frame17, Shadow_Etched_In);

      Gtk_New (User_Win.Current_Bid_Label);
      Add (User_Win.Frame17, User_Win.Current_Bid_Label);
      Set_Alignment (User_Win.Current_Bid_Label, 0.2, 0.5);
      Set_Padding (User_Win.Current_Bid_Label, 0, 0);
      Set_Justify (User_Win.Current_Bid_Label, Justify_Right);
      Set_Line_Wrap (User_Win.Current_Bid_Label, True);

      Gtk_New (User_Win.Fixed2);
      Pack_Start (User_Win.Vbox2, User_Win.Fixed2, False, False, 0);

      Gtk_New (User_Win.Frame9, "Your Balance :");
      Set_UPosition (User_Win.Frame9, 0, 0);
      Set_USize (User_Win.Frame9, 192, 80);
      Put (User_Win.Fixed2, User_Win.Frame9, 0, 0);
      Set_Border_Width (User_Win.Frame9, 3);
      Set_Shadow_Type (User_Win.Frame9, Shadow_Etched_In);

      Gtk_New (User_Win.Fixed3);
      Add (User_Win.Frame9, User_Win.Fixed3);

      Gtk_New (User_Win.Deposit_Button, "Deposit");
      Set_UPosition (User_Win.Deposit_Button, 32, 24);
      Set_USize (User_Win.Deposit_Button, 60, 30);
      Add_Accelerator (User_Win.Deposit_Button, "pressed",
                       The_Accel_Group, GDK_D, 0, Accel_Visible);
      Button_Callback.Connect
        (User_Win.Deposit_Button, "pressed",
         Button_Callback.To_Marshaller (On_Deposit_Button_Pressed'Access),
         User_Win_Access (User_Win));
      Put (User_Win.Fixed3, User_Win.Deposit_Button, 32, 24);
      Set_Border_Width (User_Win.Deposit_Button, 3);

      --  Gtk_New (User_Win.Balance_Label, Natural'Image (BBalance (Account)));
      Gtk_New (User_Win.Balance_Label, "???");

      Set_UPosition (User_Win.Balance_Label, 0, 0);
      Set_USize (User_Win.Balance_Label, 56, 24);
      Put (User_Win.Fixed3, User_Win.Balance_Label, 0, 0);
      Set_Alignment (User_Win.Balance_Label, 1.0, 0.5);
      Set_Padding (User_Win.Balance_Label, 0, 0);
      Set_Justify (User_Win.Balance_Label, Justify_Center);

      Set_Line_Wrap (User_Win.Balance_Label, False);

      Gtk_New (User_Win.Label5, "$");
      Set_UPosition (User_Win.Label5, 64, 0);
      Set_USize (User_Win.Label5, 56, 24);
      Put (User_Win.Fixed3, User_Win.Label5, 64, 0);
      Set_Alignment (User_Win.Label5, 0.5, 0.5);
      Set_Padding (User_Win.Label5, 0, 0);
      Set_Justify (User_Win.Label5, Justify_Center);
      Set_Line_Wrap (User_Win.Label5, False);

      Gtk_New (User_Win.Frame19);
      Set_UPosition (User_Win.Frame19, 200, 8);
      Set_USize (User_Win.Frame19, 112, 72);
      Put (User_Win.Fixed2, User_Win.Frame19, 200, 8);
      Set_Border_Width (User_Win.Frame19, 3);
      Set_Shadow_Type (User_Win.Frame19, Shadow_Etched_In);

      Gtk_New_Vbox (User_Win.Vbox3, False, 0);
      Add (User_Win.Frame19, User_Win.Vbox3);

      Gtk_New (User_Win.New_Auction_Button, "New Auction");
      Pack_Start (User_Win.Vbox3, User_Win.New_Auction_Button, True, True, 0);
      Add_Accelerator (User_Win.New_Auction_Button, "pressed",
                       The_Accel_Group, GDK_N, 0, Accel_Visible);
      Button_Callback.Connect
        (User_Win.New_Auction_Button, "pressed",
         Button_Callback.To_Marshaller (On_New_Auction_Button_Pressed'Access),
         User_Win_Access (User_Win));
      Set_Border_Width (User_Win.New_Auction_Button, 3);

      Gtk_New (User_Win.Quit_Button, "Quit");
      Pack_Start (User_Win.Vbox3, User_Win.Quit_Button, True, True, 0);
      Add_Accelerator (User_Win.Quit_Button, "pressed",
                       The_Accel_Group, GDK_Escape, 0, Accel_Visible);
      Button_Callback.Connect
        (User_Win.Quit_Button, "pressed",
         Button_Callback.To_Marshaller (On_Cancel_Button_Pressed'Access),
         User_Win_Access (User_Win));
      Set_Border_Width (User_Win.Quit_Button, 3);
      Set_Text (Gtk_Label (User_Win.Balance_Label),
                Natural'Image (Balance (User_ID)));
      -- declare
--          T : Transaction;
--          My_Balance : Natural;
--       begin
--          My_Balance := Transactional_Accounts.Balance (Account.all);
--          Set_Text (Gtk_Label (User_Win.Balance_Label),
--                    Natural'Image (My_Balance));
--          Set_Title (User_Win, "User " & Get_Name (User.all));
--          Commit_Transaction (T);
--       end;

      Set_Title (User_Win, "User " & Get_Name (User_Id));

      --  Set_Title (User_Win, "Auction System User");

      --  Auction List Refresh

      declare
         Auctions_Array : Remote_String_Array_Type := Get_Current_Auction_List;
         Infos : Auction_Infos_Ref;
      begin
         Freeze (User_Win.Auctions_List);
         Clear (User_Win.Auctions_List);
         for I in 1 .. Auctions_Array.Elements'Length loop
            Infos := new Auction_Infos;
            Infos.Id := Auctions_Array.ids (I);

            Insert_Element (User_Win.The_Auctions,
                            Auctions_Array.Elements (I).S,
                            Infos);

            Index := Gtk.Clist.Append
              (User_Win.Auctions_List, Auctions_Array.Elements (I).S + "");
         end loop;
         Thaw (User_Win.Auctions_List);
      end;
      My_Timeout_Handler_Id :=
        Timeout_User_Win.Add (7000, Update_Infos'Access,
                             User_Win_Access(User_Win));
   end Initialize;

end User_Win_Pkg;
