with Gtk.Window; use Gtk.Window;
with Gtk.Box; use Gtk.Box;
with Gtk.Frame; use Gtk.Frame;
with Gtk.Scrolled_Window; use Gtk.Scrolled_Window;
with Gtk.Clist; use Gtk.Clist;
with Gtk.Fixed; use Gtk.Fixed;
with Gtk.Button; use Gtk.Button;
with Gtk.Label; use Gtk.Label;
-- with Transactional_Users, Transactional_Accounts, Transactional_Auctions;
-- use Transactional_Users, Transactional_Accounts, Transactional_Auctions;

-- with Command_Buffers; use Command_Buffers;
with User_Interface; use User_Interface;
with My_Strings; use My_Strings;
with Linked_Lists_With_Refkey;
with Remote_String_Arrays; use Remote_String_Arrays;


package User_Win_Pkg is

   type Auction_Infos is record
      Description : String_Ref;
      Initial_Bid : Natural;
      --  Current_Bid : Natural;
      Id : Auction_Identifier_Type;
      Loaded : Boolean := False;
   end record;
   type Auction_Infos_Ref is access Auction_Infos;

   package Local_Auction_List is new Linked_Lists_With_Refkey
     (Element_Type => Auction_Infos_Ref,
      Key_Type => String,
      Key_Ref => String_Ref);
   use Local_Auction_List;

    type User_Win_Record is new Gtk_Window_Record with record
      Auctions_List : Gtk_Clist;
      Vbox2 : Gtk_Vbox;
      Frame12 : Gtk_Frame;
      Scrolledwindow1 : Gtk_Scrolled_Window;
      Frame8 : Gtk_Frame;
      Fixed1 : Gtk_Fixed;
      Bid_Button : Gtk_Button;
      Frame15 : Gtk_Frame;
      Name_Label : Gtk_Label;
      Frame16 : Gtk_Frame;
      Start_Bid_Label : Gtk_Label;
      Frame14 : Gtk_Frame;
      Description_Label : Gtk_Label;
      Frame17 : Gtk_Frame;
      Current_Bid_Label : Gtk_Label;
      Fixed2 : Gtk_Fixed;
      Frame9 : Gtk_Frame;
      Fixed3 : Gtk_Fixed;
      Deposit_Button : Gtk_Button;
      Balance_Label : Gtk_Label;
      Label5 : Gtk_Label;
      Frame19 : Gtk_Frame;
      Vbox3 : Gtk_Vbox;
      New_Auction_Button : Gtk_Button;
      Quit_Button : Gtk_Button;

      -- Local Auction list
      The_Auctions : Local_Auction_List.List_Type;
      --  User Data
      User_ID : User_Identifier_Type;
--       Account : Transactional_Account_Ref;
--       User_Command_Buffer : Command_Buffer_Ref;
--       Selected : Transactional_Auction_Ref := null;
      Title_Selected : String_Ref;
   end record;
   type User_Win_Access is access all User_Win_Record'Class;


   procedure Gtk_New (User_Win : out User_Win_Access);
   procedure Initialize (User_Win : access User_Win_Record'Class;
                         User_ID : User_Identifier_Type);

   --  User_Win : User_Win_Access;

end User_Win_Pkg;
