with Remote_String_Arrays; use Remote_String_Arrays;
with User_Interface; use User_Interface;

package Auction_Interface is

   pragma Remote_Call_Interface;

   function Get_Current_Bid
     (Auction : in Auction_Identifier_Type;
      User : in User_Identifier_Type) return Natural;

   function Get_Initial_Bid (Auction : in Auction_Identifier_Type;
                             User : in User_Identifier_Type)
                            return Natural;

   function Get_Name (Auction : in Auction_Identifier_Type;
                      User : in User_Identifier_Type)
                     return String;

   function Get_Description (Auction : in Auction_Identifier_Type;
                             User : in User_Identifier_Type)
                            return String;

   procedure Get_Status (Auction : in Auction_Identifier_Type;
                         User : in User_Identifier_Type;
                         Current_Bid : out Natural;
                         Status : out Status_Type);

   procedure Place_Bid (Auction : in Auction_Identifier_Type;
                        User : in User_Identifier_Type;
                        Bid : Natural);

   procedure Accept_Bid (Auction : in Auction_Identifier_Type;
                        User : in User_Identifier_Type);

   Not_Joined : exception;

end Auction_Interface;

