with Auction_Communication; use Auction_Communication;
--with Auction_Interface; use Auction_Interface;
with User_Interface; use User_Interface;
with Transactional_Auctions; use Transactional_Auctions;
with Remote_String_Arrays; use Remote_String_Arrays;

package Auction_Objects is

   subtype Index_Type is Integer range 0 .. 31;

   type String_Type (N : Index_Type := 0) is record
      S : String (1 .. N);
   end record;

   type Bidder_Node;

   type Bidder_Node_Ref is access Bidder_Node;

   type Bidder_Node is record
      Bidder_Communication : aliased Auction_Communication_Type;
      User : User_Identifier_Type;
      Next : Bidder_Node_Ref;
   end record;

   type Auction_Object_Type is limited record
      Taken : Boolean := False;
      User_Id : User_Identifier_Type;
      Winner_Id : User_Identifier_Type;
      Finished : Boolean := False;
      Auctionname : String_Type;
      Auction : Transactional_Auction_Ref;
      Communication : aliased Auction_Communication_Type;
      Bidder_Nodes : Bidder_Node_Ref;
   end record;

   type Auction_Object_Ref is access all Auction_Object_Type;

   function To_String_Type (S : String) return String_Type;

   Auction_Table : array (Auction_Identifier_Type) of Auction_Object_Type;

end Auction_Objects;
