with Ada.Streams; use Ada.Streams;

package Remote_String_Arrays is

   pragma Remote_Types;

   type Auction_Identifier_Type is new Integer range 1 .. 256;
   type Auction_Id_Array_Type is array (Integer range <>)
     of Auction_Identifier_Type;

   type Status_Type is (Active, Current_Winner, Winner, Loser);

   --  String of varying length
   subtype String_Index is Natural range 0 .. 255;

   type String_Type (N : String_Index := 0) is
      record
         S : String (1 .. N);
      end record;

   type String_Array is array (Integer range <>) of String_Type;

   type Remote_String_Array_Type (N : Natural) is record
      Elements : String_Array (1 .. N);
      Ids : Auction_Id_Array_Type (1 .. N);
   end record;

end Remote_String_Arrays;
