with Debug_Auction;
package body User_Communication is

   protected body User_Communication_Type is

      entry Called (Operation : out User_Operation_Type )
         when Current_Operation /= Nothing is
      begin
         Operation := Current_Operation;
      end Called;

      entry Get_Balance_Start when Current_Operation = Nothing is
      begin
         Current_Balance := -1;
         Current_Operation := Balance;
      end Get_Balance_Start;

      procedure Set_Balance (Value : Natural) is
      begin
         Current_Balance := Value;
         Current_Operation := Nothing;
      end Set_Balance;

      entry Get_Balance_Result (Value : out Natural)
         when Current_Balance >= 0 is
      begin
         Value := Current_Balance;
      end Get_Balance_Result;

     entry Get_User_Name_Start
         when Current_Operation = Nothing is
      begin
         if Current_Name = null then
            Current_Operation := Get_User_Name;
         end if;
      end Get_User_Name_Start;

      procedure Set_User_Name (Name : String_Ref) is
      begin
         Current_Name := Name;
         Current_Operation := Nothing;
      end Set_User_Name;

      entry Get_User_Name_Result (Name : out String_Ref)
        when Current_Name /= null is
      begin
         Name := Current_Name;
      end Get_User_Name_Result;

      entry Start_Auction (Communication : Auction_Communication_Ref;
                               Title, Description : in String;
                               Initial_Bid : in Integer;
                               Auction_Id : Auction_Identifier_Type)
         when Current_Operation = Nothing is
      begin
         Current_Initial_Bid := Initial_Bid;
         Current_Title  := new String'(Title);
         Current_Description  := new String'(Description);
         Current_Auction_Id := Auction_Id;
         Current_Communication := Communication;
         Current_Operation := Start_Auction;
      end Start_Auction;

      procedure Get_Auction_Info
        (Communication : out Auction_Communication_Ref;
         Bid : out Integer;
         Title : out String_Ref;
         Description : out String_Ref;
         Auction_Id : out Auction_Identifier_Type) is
      begin
         Communication := Current_Communication;
         Bid := Current_Initial_Bid;
         Title := Current_Title;
         Auction_Id := Current_Auction_Id;
         Description := Current_Description;
         Current_Operation := Nothing;
      end Get_Auction_Info;

      entry Deposit (Amount : Natural)
        when Current_Operation = Nothing is
      begin
         Current_Operation := Deposit;
         Current_Amount := Amount;
      end Deposit;

      procedure Get_Amount (Amount : out Natural) is
      begin
         Amount := Current_Amount;
         Current_Operation := Nothing;
      end Get_Amount;

      entry Join_Auction (Communication : Auction_Communication_Ref;
                          Auction : Transactional_Auction_Ref)
         when Current_Operation = Nothing is
      begin
         Current_Communication := Communication;
         Current_Auction := Auction;
         Current_Operation := Join_Auction;
      end Join_Auction;

      procedure Get_Join_Info
        (Communication : out Auction_Communication_Ref;
         Auction : out Transactional_Auction_Ref) is
      begin
         Communication := Current_Communication;
         Auction := Current_Auction;
         Current_Operation := Nothing;
      end Get_Join_Info;

   end User_Communication_Type;

end User_Communication;
