-- with Auction_Interface; use Auction_Interface;
--  with Auction_Lists; use Auction_Lists;
with Remote_String_Arrays; use Remote_String_Arrays;

package User_Interface is

   pragma Remote_Call_Interface;

   type User_Identifier_Type is new Integer range 1 .. 256;

   --  type Auction_Names_Array_Type is array (Integer range <>) of String;

   procedure Deposit (User   : in User_Identifier_Type;
                      Amount : in Natural);

   function Balance (User : in User_Identifier_Type) return Natural;

   function Get_Name (User : in User_Identifier_Type) return String;

   function Start_Auction (User : in User_Identifier_Type;
                           Title, Description : in String;
                           Initial_Bid : in Integer)
      return Auction_Identifier_Type;

   function Join_Auction (User : in User_Identifier_Type;
                          Auctionname : in String) return Auction_Identifier_Type;

   Auction_Exists, Too_Much_Auctions, No_Such_Auction : exception;

end User_Interface;
