with User_Communication; use User_Communication;
with User_Interface; use User_Interface;

package User_Objects is

   subtype Index_Type is Integer range 0 .. 31;

   type String_Type (N : Index_Type := 0) is record
      S : String (1 .. N);
   end record;

   type User_Object_Type is limited record
      Taken : Boolean := False;
      Username : String_Type;
      Communication : aliased User_Communication_Type;
   end record;

   type User_Object_Ref is access all User_Object_Type;

   function To_String_Type (S : String) return String_Type;

   User_Table : array (User_Identifier_Type) of User_Object_Type;

end User_Objects;
