-------------------------------------------------------------------------------
--                             Accounts (body)                               --
--                                                                           --
--                        by Simon Schule,                                   --
--             Last modified 26.09.2000, by Xavier Caron                     --
--                      e-mail:  xavier.caron@epfl.ch                        --
--                                                                           --
--                                                                           --
--  The Account class contains the type for an user account of               --
--  the auction system.                                                      --
-------------------------------------------------------------------------------

package body Accounts is

   procedure Deposit (A : in out Account_Type;
                      Value : in Natural) is
   begin
      A.Balance := A.Balance + Value;
   end Deposit;

   procedure Withdraw (A : in out Account_Type;
                       Value : in Natural) is
   begin
      A.Balance := A.Balance - Value;
   exception
      when Constraint_Error =>
         raise Not_Enough_Funds;
   end Withdraw;

   function Balance (A : Account_Type) return Natural is
   begin
      return A.Balance;
   end Balance;

   procedure My_Write (Stream : access Ada.Streams.Root_Stream_Type'Class;
                       Item   : in Account_Type) is
   begin
      Natural'Write (Stream, Item.Balance);
   end My_Write;

   procedure My_Read (Stream : access Ada.Streams.Root_Stream_Type'Class;
                      Item   : out Account_Type) is
   begin
      Natural'Read (Stream, Item.Balance);
   end My_Read;

end Accounts;

