-------------------------------------------------------------------------------
--                            Server Utilities                               --
--                                                                           --
--                  by Xavier Caron, last modified 08.03.2001                --
--                                                                           --
--                      e-mail:  xavier.caron@epfl.ch                        --
--                                                                           --
--  This package provide utilities for the server of the DASK                --
-------------------------------------------------------------------------------
with Transactional_Accounts; use Transactional_Accounts;
with Transactional_Users; use Transactional_Users;

package Server_Utilities is

   function Login_Correct (Name : String; Password : String)
                          return Boolean;

   procedure Create_New_User (Name : String; Password : String);

   function Get_The_User (Name : String; Password : String)
                     return Transactional_User_Ref;

   function Get_The_Account (User : Transactional_User_Ref)
                        return Transactional_Account_Ref;

end Server_Utilities;
