with Debug; use Debug;

package body Tasks_Counter is

   type Task_Array is array (Natural range <>) of Task_Id;

   protected Object is

      procedure Insert;

      procedure Remove;

   end Object;

   My_Tasks : Task_Array (1 .. 100) := (others => Null_Task_Id);

   protected body Object is

      procedure Insert is
      begin
         for I in My_Tasks'Range loop
            if My_Tasks (I) = Null_Task_Id then
               My_Tasks (I) := Current_Task;
               return;
            end if;
         end loop;
         raise Task_List_Full;
      end Insert;

      procedure Remove is
         Current : Task_Id := Current_Task;
      begin
         for I in My_Tasks'Range loop
            if My_Tasks (I) = Current then
               My_Tasks (I) := Null_Task_Id;
               return;
            end if;
         end loop;
         raise Task_List_Full;
      end Remove;

   end Object;

   procedure Initialize (T : in out Task_Registration_Type) is
   begin
      Object.Insert;
   end Initialize;

   procedure Finalize (T : in out Task_Registration_Type) is
   begin
      Object.Remove;
   end Finalize;

   procedure Kill_All_Tasks is
   begin
      for I in My_Tasks'Range loop
         if My_Tasks (I) /= Null_Task_Id then
            Put_Line ("Aborting task");
            Abort_Task (My_Tasks (I));
         end if;
      end loop;
   end Kill_All_Tasks;

   procedure Insert is
   begin
      Object.Insert;
   end Insert;

   procedure Remove is
   begin
      Object.Remove;
   end Remove;

end Tasks_Counter;
