with Ada.Finalization;
with Ada.Task_Identification; use Ada.Task_Identification;

package Tasks_Counter is

   type Task_Registration_Type is limited private;

   Task_List_Full : exception;

   procedure Kill_All_Tasks;

   procedure Insert;

   procedure Remove;

private

   type Task_Registration_Type is new Ada.Finalization.Limited_Controlled
     with record
        My_Task : Task_Id;
   end record;

   procedure Initialize (T : in out Task_Registration_Type);

   procedure Finalize (T : in out Task_Registration_Type);

end Tasks_Counter;
